/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of BDB.xs. Do not edit this file, edit BDB.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "BDB.xs"
#define X_STACKSIZE 1024 * 128 + sizeof (long) * 64 * 1024 / 4

#include "xthread.h"

#include <errno.h>

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "schmorp.h"

// perl stupidly defines these as argument-less macros, breaking
// lots and lots of code.
#undef open
#undef close
#undef abort
#undef malloc
#undef free
#undef send

#include <stddef.h>
#include <stdlib.h>
#include <errno.h>
#include <sys/types.h>
#include <limits.h>
#include <fcntl.h>

#ifndef _WIN32
# include <sys/time.h>
# include <unistd.h>
#endif

#include <db.h>

#define DBVER DB_VERSION_MAJOR * 100 + DB_VERSION_MINOR

#if DBVER < 403
# error you need Berkeley DB 4.3 or a newer version installed
#endif

/* number of seconds after which idle threads exit */
#define IDLE_TIMEOUT 10

typedef SV          SV_mutable;

typedef DB_ENV      DB_ENV_ornull;
typedef DB_TXN      DB_TXN_ornull;
typedef DBC         DBC_ornull;
typedef DB          DB_ornull;

typedef DB_ENV      DB_ENV_ornuked;
typedef DB_TXN      DB_TXN_ornuked;
typedef DBC         DBC_ornuked;
typedef DB          DB_ornuked;

#if DBVER >= 403
typedef DB_SEQUENCE DB_SEQUENCE_ornull;
typedef DB_SEQUENCE DB_SEQUENCE_ornuked;
#endif

typedef char *bdb_filename;

static SV *prepare_cb;

static HV
  *bdb_stash,
  *bdb_env_stash,
  *bdb_txn_stash,
  *bdb_cursor_stash,
  *bdb_db_stash,
  *bdb_sequence_stash;

#if DBVER >= 406
# define c_close close 
# define c_count count 
# define c_del   del   
# define c_dup   dup   
# define c_get   get   
# define c_pget  pget  
# define c_put   put   
#endif

static char *
get_bdb_filename (SV *sv)
{
  if (!SvOK (sv))
    return 0;

#if _WIN32
  /* win32 madness + win32 perl absolutely brokenness make for horrible hacks */
  {
    STRLEN len;
    char *src = SvPVbyte (sv, len);
    SV *t1 = sv_newmortal ();
    SV *t2 = sv_newmortal ();

    sv_upgrade (t1, SVt_PV); SvPOK_only (t1); SvGROW (t1, len * 16 + 1);
    sv_upgrade (t2, SVt_PV); SvPOK_only (t2); SvGROW (t2, len * 16 + 1);

    len = MultiByteToWideChar (CP_ACP, 0, src, len, (WCHAR *)SvPVX (t1), SvLEN (t1) / sizeof (WCHAR));
    len = WideCharToMultiByte (CP_UTF8, 0, (WCHAR *)SvPVX (t1), len, SvPVX (t2), SvLEN (t2), 0, 0);
    SvPOK_only (t2);
    SvPVX (t2)[len] = 0;
    SvCUR_set (t2, len);

    return SvPVX (t2);
  }
#else
  return SvPVbyte_nolen (sv);
#endif
}

static void
debug_errcall (const DB_ENV *dbenv, const char *errpfx, const char *msg)
{
  printf ("err[%s]\n", msg);
}

static void
debug_msgcall (const DB_ENV *dbenv, const char *msg)
{
  printf ("msg[%s]\n", msg);
}

static char *
strdup_ornull (const char *s)
{
  return s ? strdup (s) : 0;
}

static void
sv_to_dbt (DBT *dbt, SV *sv)
{
  STRLEN len;
  char *data = SvPVbyte (sv, len);

  dbt->data = malloc (len);
  memcpy (dbt->data, data, len);
  dbt->size = len;
  dbt->flags = DB_DBT_REALLOC;
}
	
static void
dbt_to_sv (SV *sv, DBT *dbt)
{
  if (sv)
    {
      SvREADONLY_off (sv);

      if (dbt->data)
        sv_setpvn_mg (sv, dbt->data, dbt->size);
      else
        sv_setsv_mg (sv, &PL_sv_undef);

      SvREFCNT_dec (sv);
    }

  free (dbt->data);
}
	
enum {
  REQ_QUIT,
  REQ_ENV_OPEN, REQ_ENV_CLOSE, REQ_ENV_TXN_CHECKPOINT, REQ_ENV_LOCK_DETECT,
  REQ_ENV_MEMP_SYNC, REQ_ENV_MEMP_TRICKLE, REQ_ENV_DBREMOVE, REQ_ENV_DBRENAME,
  REQ_ENV_LOG_ARCHIVE, REQ_ENV_LSN_RESET, REQ_ENV_FILEID_RESET,
  REQ_DB_OPEN, REQ_DB_CLOSE, REQ_DB_COMPACT, REQ_DB_SYNC, REQ_DB_VERIFY, REQ_DB_UPGRADE,
  REQ_DB_PUT, REQ_DB_EXISTS, REQ_DB_GET, REQ_DB_PGET, REQ_DB_DEL, REQ_DB_KEY_RANGE,
  REQ_TXN_COMMIT, REQ_TXN_ABORT, REQ_TXN_FINISH,
  REQ_C_CLOSE, REQ_C_COUNT, REQ_C_PUT, REQ_C_GET, REQ_C_PGET, REQ_C_DEL,
  REQ_SEQ_OPEN, REQ_SEQ_CLOSE, REQ_SEQ_GET, REQ_SEQ_REMOVE,
};

typedef struct bdb_cb
{
  struct bdb_cb *volatile next;
  SV *callback;
  int type, pri, result;

  DB_ENV *env;
  DB *db;
  DB_TXN *txn;
  DBC *dbc;

  UV uv1;
  int int1, int2;
  U32 uint1, uint2;
  char *buf1, *buf2, *buf3;
  SV *sv1, *sv2, *sv3;

  DBT dbt1, dbt2, dbt3;
  DB_KEY_RANGE key_range;
#if DBVER >= 403
  DB_SEQUENCE *seq;
  db_seq_t seq_t;
#endif

  SV *rsv1, *rsv2; // keep some request objects alive
} bdb_cb;

typedef bdb_cb *bdb_req;

enum {
  PRI_MIN     = -4,
  PRI_MAX     =  4,

  DEFAULT_PRI = 0,
  PRI_BIAS    = -PRI_MIN,
  NUM_PRI     = PRI_MAX + PRI_BIAS + 1,
};

#define AIO_TICKS ((1000000 + 1023) >> 10)

static SV *on_next_submit;

static unsigned int max_poll_time = 0;
static unsigned int max_poll_reqs = 0;

/* calculcate time difference in ~1/AIO_TICKS of a second */
static int tvdiff (struct timeval *tv1, struct timeval *tv2)
{
  return  (tv2->tv_sec  - tv1->tv_sec ) * AIO_TICKS
       + ((tv2->tv_usec - tv1->tv_usec) >> 10);
}

static int next_pri = DEFAULT_PRI + PRI_BIAS;

static unsigned int started, idle, wanted;

/* worker threads management */
static xmutex_t wrklock = X_MUTEX_INIT;

typedef struct worker {
  /* locked by wrklock */
  struct worker *prev, *next;

  xthread_t tid;

  /* locked by reslock, reqlock or wrklock */
  bdb_req req; /* currently processed request */
  void *dbuf;
  DIR *dirp;
} worker;

static worker wrk_first = { &wrk_first, &wrk_first, 0 };

static void worker_clear (worker *wrk)
{
}

static void worker_free (worker *wrk)
{
  wrk->next->prev = wrk->prev;
  wrk->prev->next = wrk->next;

  free (wrk);
}

static volatile unsigned int nreqs, nready, npending;
static volatile unsigned int max_idle = 4;
static volatile unsigned int max_outstanding = 0xffffffff;
static s_epipe respipe;

static xmutex_t reslock = X_MUTEX_INIT;
static xmutex_t reqlock = X_MUTEX_INIT;
static xcond_t  reqwait = X_COND_INIT;

#if WORDACCESS_UNSAFE

static unsigned int get_nready (void)
{
  unsigned int retval;

  X_LOCK   (reqlock);
  retval = nready;
  X_UNLOCK (reqlock);

  return retval;
}

static unsigned int get_npending (void)
{
  unsigned int retval;

  X_LOCK   (reslock);
  retval = npending;
  X_UNLOCK (reslock);

  return retval;
}

static unsigned int get_nthreads (void)
{
  unsigned int retval;

  X_LOCK   (wrklock);
  retval = started;
  X_UNLOCK (wrklock);

  return retval;
}

#else

# define get_nready()   nready
# define get_npending() npending
# define get_nthreads() started

#endif

/*
 * a somewhat faster data structure might be nice, but
 * with 8 priorities this actually needs <20 insns
 * per shift, the most expensive operation.
 */
typedef struct {
  bdb_req qs[NUM_PRI], qe[NUM_PRI]; /* qstart, qend */
  int size;
} reqq;

static reqq req_queue;
static reqq res_queue;

int reqq_push (reqq *q, bdb_req req)
{
  int pri = req->pri;
  req->next = 0;

  if (q->qe[pri])
    {
      q->qe[pri]->next = req;
      q->qe[pri] = req;
    }
  else
    q->qe[pri] = q->qs[pri] = req;

  return q->size++;
}

bdb_req reqq_shift (reqq *q)
{
  int pri;

  if (!q->size)
    return 0;

  --q->size;

  for (pri = NUM_PRI; pri--; )
    {
      bdb_req req = q->qs[pri];

      if (req)
        {
          if (!(q->qs[pri] = req->next))
            q->qe[pri] = 0;

          return req;
        }
    }

  abort ();
}

static int poll_cb (void);
static void req_free (bdb_req req);

static int req_invoke (bdb_req req)
{
  switch (req->type)
    {
      case REQ_DB_CLOSE:
        SvREFCNT_dec (req->sv1);
        break;

      case REQ_DB_GET:
      case REQ_DB_PGET:
      case REQ_C_GET:
      case REQ_C_PGET:
      case REQ_DB_PUT:
      case REQ_C_PUT:
        dbt_to_sv (req->sv1, &req->dbt1);
        dbt_to_sv (req->sv2, &req->dbt2);
        dbt_to_sv (req->sv3, &req->dbt3);
        break;

      case REQ_DB_KEY_RANGE:
        {
          AV *av = newAV ();

          av_push (av, newSVnv (req->key_range.less));
          av_push (av, newSVnv (req->key_range.equal));
          av_push (av, newSVnv (req->key_range.greater));

          av = (AV *)newRV_noinc ((SV *)av);

          SvREADONLY_off (req->sv1);
          sv_setsv_mg (req->sv1, newRV_noinc ((SV *)av));
          SvREFCNT_dec (av);
          SvREFCNT_dec (req->sv1);
        }
        break;

#if DBVER >= 403
      case REQ_SEQ_GET:
        SvREADONLY_off (req->sv1);

        if (sizeof (IV) > 4)
          sv_setiv_mg (req->sv1, (IV)req->seq_t);
        else
          sv_setnv_mg (req->sv1, (NV)req->seq_t);

        SvREFCNT_dec (req->sv1);
        break;
#endif

      case REQ_ENV_LOG_ARCHIVE:
        {
          AV *av = newAV ();
          char **listp = (char **)req->buf1;

          if (listp)
            while (*listp)
              av_push (av, newSVpv (*listp, 0)), ++listp;

          av = (AV *)newRV_noinc ((SV *)av);

          SvREADONLY_off (req->sv1);
          sv_setsv_mg (req->sv1, (SV *)av);
          SvREFCNT_dec (av);
          SvREFCNT_dec (req->sv1);
        }
        break;
    }

  errno = req->result;

  if (req->callback)
    {
      dSP;

      ENTER;
      SAVETMPS;
      PUSHMARK (SP);

      PUTBACK;
      call_sv (req->callback, G_VOID | G_EVAL);
      SPAGAIN;

      FREETMPS;
      LEAVE;

      return !SvTRUE (ERRSV);
    }

  return 1;
}

static void req_free (bdb_req req)
{
  SvREFCNT_dec (req->callback);

  SvREFCNT_dec (req->rsv1);
  SvREFCNT_dec (req->rsv2);

  free (req->buf1);
  free (req->buf2);
  free (req->buf3);

  Safefree (req);
}

static void
create_respipe (void)
{
  if (s_epipe_renew (&respipe))
    croak ("BDB: unable to create event pipe");
}

static void bdb_request (bdb_req req);
X_THREAD_PROC (bdb_proc);

static void start_thread (void)
{
  worker *wrk = calloc (1, sizeof (worker));

  if (!wrk)
    croak ("unable to allocate worker thread data");

  X_LOCK (wrklock);
  if (xthread_create (&wrk->tid, bdb_proc, (void *)wrk))
    {
      wrk->prev = &wrk_first;
      wrk->next = wrk_first.next;
      wrk_first.next->prev = wrk;
      wrk_first.next = wrk;
      ++started;
    }
  else
    free (wrk);

  X_UNLOCK (wrklock);
}

static void maybe_start_thread (void)
{
  if (get_nthreads () >= wanted)
    return;
  
  /* todo: maybe use idle here, but might be less exact */
  if (0 <= (int)get_nthreads () + (int)get_npending () - (int)nreqs)
    return;

  start_thread ();
}

static void req_send (bdb_req req)
{
  SV *wait_callback = 0;

  if (on_next_submit)
    {
      dSP;
      SV *cb = sv_2mortal (on_next_submit);

      on_next_submit = 0;

      PUSHMARK (SP);
      PUTBACK;
      call_sv (cb, G_DISCARD | G_EVAL);
      SPAGAIN;
    }

  // synthesize callback if none given
  if (!req->callback)
    {
      if (SvOK (prepare_cb))
        {
          int count;

          dSP;
          PUSHMARK (SP);
          PUTBACK;
          count = call_sv (prepare_cb, G_ARRAY);
          SPAGAIN;

          if (count != 2)
            croak ("sync prepare callback must return exactly two values\n");

          wait_callback = POPs;
          req->callback = SvREFCNT_inc (POPs);
        }
      else
        {
          // execute request synchronously
          bdb_request (req);
          req_invoke (req);
          req_free (req);
          return;
        }
    }

  ++nreqs;

  X_LOCK (reqlock);
  ++nready;
  reqq_push (&req_queue, req);
  X_COND_SIGNAL (reqwait);
  X_UNLOCK (reqlock);

  maybe_start_thread ();

  if (wait_callback)
    {
      dSP;
      PUSHMARK (SP);
      PUTBACK;
      call_sv (wait_callback, G_DISCARD);
    }
}

static void end_thread (void)
{
  bdb_req req = calloc (1, sizeof (bdb_cb));

  req->type = REQ_QUIT;
  req->pri  = PRI_MAX + PRI_BIAS;

  X_LOCK (reqlock);
  reqq_push (&req_queue, req);
  X_COND_SIGNAL (reqwait);
  X_UNLOCK (reqlock);

  X_LOCK (wrklock);
  --started;
  X_UNLOCK (wrklock);
}

static void set_max_idle (int nthreads)
{
  if (WORDACCESS_UNSAFE) X_LOCK   (reqlock);
  max_idle = nthreads <= 0 ? 1 : nthreads;
  if (WORDACCESS_UNSAFE) X_UNLOCK (reqlock);
}

static void min_parallel (int nthreads)
{
  if (wanted < nthreads)
    wanted = nthreads;
}

static void max_parallel (int nthreads)
{
  if (wanted > nthreads)
    wanted = nthreads;

  while (started > wanted)
    end_thread ();
}

static void poll_wait (void)
{
  while (nreqs)
    {
      int size;
      if (WORDACCESS_UNSAFE) X_LOCK   (reslock);
      size = res_queue.size;
      if (WORDACCESS_UNSAFE) X_UNLOCK (reslock);

      if (size)
        return;

      maybe_start_thread ();

      s_epipe_wait (&respipe);
    }
}

static int poll_cb (void)
{
  dSP;
  int count = 0;
  int maxreqs = max_poll_reqs;
  int do_croak = 0;
  struct timeval tv_start, tv_now;
  bdb_req req;

  if (max_poll_time)
    gettimeofday (&tv_start, 0);

  for (;;)
    {
      for (;;)
        {
          maybe_start_thread ();

          X_LOCK (reslock);
          req = reqq_shift (&res_queue);

          if (req)
            {
              --npending;

              if (!res_queue.size)
                /* read any signals sent by the worker threads */
                s_epipe_drain (&respipe);
            }

          X_UNLOCK (reslock);

          if (!req)
            break;

          --nreqs;

          if (!req_invoke (req))
            {
              req_free (req);
              croak (0);
            }

          count++;

          req_free (req);

          if (maxreqs && !--maxreqs)
            break;

          if (max_poll_time)
            {
              gettimeofday (&tv_now, 0);

              if (tvdiff (&tv_start, &tv_now) >= max_poll_time)
                break;
            }
        }

      if (nreqs <= max_outstanding)
        break;

      poll_wait ();

      ++maxreqs;
    }

  return count;
}

/*****************************************************************************/

static void
bdb_request (bdb_req req)
{
  switch (req->type)
    {
      case REQ_ENV_OPEN:
        req->result = req->env->open (req->env, req->buf1, req->uint1, req->int1);
        break;

      case REQ_ENV_CLOSE:
        req->result = req->env->close (req->env, req->uint1);
        break;

      case REQ_ENV_TXN_CHECKPOINT:
        req->result = req->env->txn_checkpoint (req->env, req->uint1, req->int1, req->uint2);
        break;

      case REQ_ENV_LOCK_DETECT:
        req->result = req->env->lock_detect (req->env, req->uint1, req->uint2, &req->int1);
        break;

      case REQ_ENV_MEMP_SYNC:
        req->result = req->env->memp_sync (req->env, 0);
        break;

      case REQ_ENV_MEMP_TRICKLE:
        req->result = req->env->memp_trickle (req->env, req->int1, &req->int2);
        break;

      case REQ_ENV_DBREMOVE:
        req->result = req->env->dbremove (req->env, req->txn, req->buf1, req->buf2, req->uint1);
        break;

      case REQ_ENV_DBRENAME:
        req->result = req->env->dbrename (req->env, req->txn, req->buf1, req->buf2, req->buf3, req->uint1);
        break;

      case REQ_DB_OPEN:
        req->result = req->db->open (req->db, req->txn, req->buf1, req->buf2, req->int1, req->uint1, req->int2);
        break;

      case REQ_DB_CLOSE:
        req->result = req->db->close (req->db, req->uint1);
        break;

#if DBVER >= 404
      case REQ_DB_COMPACT:
        req->result = req->db->compact (req->db, req->txn, req->dbt1.data ? &req->dbt1 : 0, req->dbt2.data ? &req->dbt2 : 0, 0, req->uint1, 0);
        break;
#endif

      case REQ_DB_SYNC:
        req->result = req->db->sync (req->db, req->uint1);
        break;

      case REQ_DB_VERIFY:
        req->result = req->db->verify (req->db, req->buf1, req->buf2, 0, req->uint1);
        break;

      case REQ_DB_UPGRADE:
        req->result = req->db->upgrade (req->db, req->buf1, req->uint1);
        break;

      case REQ_DB_PUT:
        req->result = req->db->put (req->db, req->txn, &req->dbt1, &req->dbt2, req->uint1);
        break;

#if DBVER >= 406
      case REQ_DB_EXISTS:
        req->result = req->db->exists (req->db, req->txn, &req->dbt1, req->uint1);
        break;
#endif
      case REQ_DB_GET:
        req->result = req->db->get (req->db, req->txn, &req->dbt1, &req->dbt3, req->uint1);
        break;

      case REQ_DB_PGET:
        req->result = req->db->pget (req->db, req->txn, &req->dbt1, &req->dbt2, &req->dbt3, req->uint1);
        break;

      case REQ_DB_DEL:
        req->result = req->db->del (req->db, req->txn, &req->dbt1, req->uint1);
        break;

      case REQ_DB_KEY_RANGE:
        req->result = req->db->key_range (req->db, req->txn, &req->dbt1, &req->key_range, req->uint1);
        break;

      case REQ_TXN_COMMIT:
        req->result = req->txn->commit (req->txn, req->uint1);
        break;

      case REQ_TXN_ABORT:
        req->result = req->txn->abort (req->txn);
        break;

      case REQ_TXN_FINISH:
        if (req->txn->flags & TXN_DEADLOCK)
          {
            req->result = req->txn->abort (req->txn);
            if (!req->result)
              req->result = DB_LOCK_DEADLOCK;
          }
        else
          req->result = req->txn->commit (req->txn, req->uint1);
        break;

      case REQ_C_CLOSE:
        req->result = req->dbc->c_close (req->dbc);
        break;

      case REQ_C_COUNT:
        {
          db_recno_t recno;
          req->result = req->dbc->c_count (req->dbc, &recno, req->uint1);
          req->uv1 = recno;
        }
        break;

      case REQ_C_PUT:
        req->result = req->dbc->c_put (req->dbc, &req->dbt1, &req->dbt2, req->uint1);
        break;

      case REQ_C_GET:
        req->result = req->dbc->c_get (req->dbc, &req->dbt1, &req->dbt3, req->uint1);
        break;

      case REQ_C_PGET:
        req->result = req->dbc->c_pget (req->dbc, &req->dbt1, &req->dbt2, &req->dbt3, req->uint1);
        break;

      case REQ_C_DEL:
        req->result = req->dbc->c_del (req->dbc, req->uint1);
        break;

#if DBVER >= 403
      case REQ_SEQ_OPEN:
        req->result = req->seq->open (req->seq, req->txn, &req->dbt1, req->uint1);
        break;

      case REQ_SEQ_CLOSE:
        req->result = req->seq->close (req->seq, req->uint1);
        break;

      case REQ_SEQ_GET:
        req->result = req->seq->get (req->seq, req->txn, req->int1, &req->seq_t, req->uint1);
        break;

      case REQ_SEQ_REMOVE:
        req->result = req->seq->remove (req->seq, req->txn, req->uint1);
        break;
#endif

#if DBVER >= 407
      case REQ_ENV_LSN_RESET:
        req->result = req->env->lsn_reset (req->env, req->buf1, req->uint1);
        break;

      case REQ_ENV_FILEID_RESET:
        req->result = req->env->fileid_reset (req->env, req->buf1, req->uint1);
        break;
#endif

      case REQ_ENV_LOG_ARCHIVE:
        {
          char **listp = 0; /* DB_ARCH_REMOVE does not touch listp, contrary to docs */
          req->result = req->env->log_archive (req->env, &listp, req->uint1);
          req->buf1 = (char *)listp;
        }
        break;

      default:
        req->result = ENOSYS;
        break;
    }

  if (req->txn && (req->result > 0 || req->result == DB_LOCK_NOTGRANTED))
    req->txn->flags |= TXN_DEADLOCK;
}

X_THREAD_PROC (bdb_proc)
{
  bdb_req req;
  struct timespec ts;
  worker *self = (worker *)thr_arg;

  /* try to distribute timeouts somewhat evenly */
  ts.tv_nsec = ((unsigned long)self & 1023UL) * (1000000000UL / 1024UL);

  for (;;)
    {
      ts.tv_sec = time (0) + IDLE_TIMEOUT;

      X_LOCK (reqlock);

      for (;;)
        {
          self->req = req = reqq_shift (&req_queue);

          if (req)
            break;

          ++idle;

          if (X_COND_TIMEDWAIT (reqwait, reqlock, ts)
              == ETIMEDOUT)
            {
              if (idle > max_idle)
                {
                  --idle;
                  X_UNLOCK (reqlock);
                  X_LOCK (wrklock);
                  --started;
                  X_UNLOCK (wrklock);
                  goto quit;
                }

              /* we are allowed to idle, so do so without any timeout */
              X_COND_WAIT (reqwait, reqlock);
              ts.tv_sec  = time (0) + IDLE_TIMEOUT;
            }

          --idle;
        }

      --nready;

      X_UNLOCK (reqlock);

      if (req->type == REQ_QUIT)
        {
          X_LOCK (reslock);
          free (req);
          self->req = 0;
          X_UNLOCK (reslock);

          goto quit;
        }

      bdb_request (req);

      X_LOCK (reslock);

      ++npending;

      if (!reqq_push (&res_queue, req))
        s_epipe_signal (&respipe);

      self->req = 0;
      worker_clear (self);

      X_UNLOCK (reslock);
    }

quit:
  X_LOCK (wrklock);
  worker_free (self);
  X_UNLOCK (wrklock);

  return 0;
}

/*****************************************************************************/

static void atfork_prepare (void)
{
  X_LOCK (wrklock);
  X_LOCK (reqlock);
  X_LOCK (reslock);
}

static void atfork_parent (void)
{
  X_UNLOCK (reslock);
  X_UNLOCK (reqlock);
  X_UNLOCK (wrklock);
}

static void atfork_child (void)
{
  bdb_req prv;

  while (prv = reqq_shift (&req_queue))
    req_free (prv);

  while (prv = reqq_shift (&res_queue))
    req_free (prv);

  while (wrk_first.next != &wrk_first)
    {
      worker *wrk = wrk_first.next;

      if (wrk->req)
        req_free (wrk->req);

      worker_clear (wrk);
      worker_free (wrk);
    }

  started  = 0;
  idle     = 0;
  nreqs    = 0;
  nready   = 0;
  npending = 0;

  create_respipe ();

  atfork_parent ();
}

#define dREQ(reqtype,rsvcnt)					\
  bdb_req req;							\
  int req_pri = next_pri;					\
  next_pri = DEFAULT_PRI + PRI_BIAS;				\
								\
  if (callback && SvOK (callback))				\
    croak ("callback has illegal type or extra arguments");	\
								\
  Newz (0, req, 1, bdb_cb);					\
  if (!req)							\
    croak ("out of memory during bdb_req allocation");		\
								\
  req->callback = SvREFCNT_inc (cb);				\
  req->type = (reqtype);					\
  req->pri  = req_pri;						\
  if (rsvcnt >= 1) req->rsv1 = SvREFCNT_inc (ST (0));		\
  if (rsvcnt >= 2) req->rsv2 = SvREFCNT_inc (ST (1));		\
  (void)0;

#define REQ_SEND						\
  req_send (req)

#define SvPTR(var, arg, type, stash, class, nullok)				\
  if (!SvOK (arg))								\
    {										\
      if (nullok != 1)								\
        croak (# var " must be a " # class " object, not undef");		\
										\
      (var) = 0;								\
    }										\
  else if (SvSTASH (SvRV (arg)) == stash || sv_derived_from ((arg), # class))   \
    {                                                           		\
      IV tmp = SvIV ((SV*) SvRV (arg));                         		\
      (var) = INT2PTR (type, tmp);                              		\
      if (!var && nullok != 2)							\
        croak (# var " is not a valid " # class " object anymore");		\
    }                                                           		\
  else                                                          		\
    croak (# var " is not of type " # class);

#define ARG_MUTABLE(name)							\
  if (SvREADONLY (name))							\
    croak ("argument " #name " is read-only/constant, but the request requires it to be mutable");

static SV *
newSVptr (void *ptr, HV *stash)
{
  SV *rv = NEWSV (0, 0);
  sv_upgrade (rv, SVt_PVMG);
  sv_setiv (rv, PTR2IV (ptr));

  return sv_bless (newRV_noinc (rv), stash);
}

static void
ptr_nuke (SV *sv)
{
  assert (SvROK (sv));
  sv_setiv (SvRV (sv), 0);
}

static int
errno_get (pTHX_ SV *sv, MAGIC *mg)
{
  if (*mg->mg_ptr == '!') // should always be the case
    if (-30999 <= errno && errno <= -30800)
      {
        sv_setnv (sv, (NV)errno);
        sv_setpv (sv, db_strerror (errno));
        SvNOK_on (sv); /* what a wonderful hack! */
                       // ^^^ copied from perl sources
        return 0;
      }

  return PL_vtbl_sv.svt_get (aTHX_ sv, mg);
}

static MGVTBL vtbl_errno;

// this wonderful hack :( patches perl's $! variable to support our errno values
static void
patch_errno (void)
{
  SV *sv;
  MAGIC *mg;

  if (!(sv = get_sv ("!", 1)))
    return;

  if (!(mg = mg_find (sv, PERL_MAGIC_sv)))
    return;

  if (mg->mg_virtual != &PL_vtbl_sv)
    return;

  vtbl_errno = PL_vtbl_sv;
  vtbl_errno.svt_get = errno_get;
  mg->mg_virtual = &vtbl_errno;
}

#if __GNUC__ >= 4
# define noinline                   __attribute__ ((noinline))
#else
# define noinline
#endif

static noinline SV *
pop_callback (I32 *ritems, SV *sv)
{
  if (SvROK (sv))
    {
      HV *st;
      GV *gvp;
      CV *cv;
      const char *name;

      /* forgive me */
      if (SvTYPE (SvRV (sv)) == SVt_PVMG
          && (st = SvSTASH (SvRV (sv)))
          && (name = HvNAME_get (st))
          && (name [0] == 'B' && name [1] == 'D' && name [2] == 'B' && name [3] == ':'))
        return 0;

      if ((cv = sv_2cv (sv, &st, &gvp, 0)))
        {
          --*ritems;
          return (SV *)cv;
        }
    }

  return 0;
}

/*****************************************************************************/

#if 0
static int
bt_pfxc_compare (DB *db, const DBT *dbt1, const DBT *dbt2)
{
  ssize_t size1 = dbt1->size;
  ssize_t size2 = dbt2->size;
  int res = memcmp ((void *)dbt1->data, (void *)dbt2->data,
                    size1 <= size2 ? size1 : size2);

  if (res)
    return res;
  else if (size1 - size2)
    return size1 - size2;
  else
    return 0;
}

static size_t
bt_pfxc_prefix_x (DB *db, const DBT *dbt1, const DBT *dbt2)
{
  ssize_t size1 = dbt1->size;
  ssize_t size2 = dbt2->size;
  u_int8_t *p1 = (u_int8_t *)dbt1->data;
  u_int8_t *p2 = (u_int8_t *)dbt2->data;
  u_int8_t *pe = p1 + (size1 <= size2 ? size1 : size2);

  while (p1 < pe)
    if (*p1++ != *p2++)
      return p1 - (u_int8_t *)dbt1->data - 1;

  if (size1 < size2) return size1 + 1;
  if (size1 > size2) return size2 + 1;

  return size1;
}
#endif

/*****************************************************************************/

/* stupid windows defines CALLBACK as well */
#undef CALLBACK
#define CALLBACK SV *cb = pop_callback (&items, ST (items - 1));

#line 1209 "BDB.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 1353 "BDB.c"

XS_EUPXS(XS_BDB_max_poll_reqs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB_max_poll_reqs)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "nreqs");
    {
	int	nreqs = (int)SvIV(ST(0))
;
#line 1452 "BDB.xs"
        max_poll_reqs = nreqs;
#line 1366 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BDB_max_poll_time); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB_max_poll_time)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "nseconds");
    {
	double	nseconds = (double)SvNV(ST(0))
;
#line 1458 "BDB.xs"
        max_poll_time = nseconds * AIO_TICKS;
#line 1383 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BDB_min_parallel); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB_min_parallel)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "nthreads");
    {
	int	nthreads = (int)SvIV(ST(0))
;

	min_parallel(nthreads);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BDB_max_parallel); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB_max_parallel)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "nthreads");
    {
	int	nthreads = (int)SvIV(ST(0))
;

	max_parallel(nthreads);
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BDB_max_idle); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB_max_idle)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "nthreads");
    {
	int	nthreads = (int)SvIV(ST(0))
;
#line 1472 "BDB.xs"
        set_max_idle (nthreads);
#line 1432 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BDB_max_outstanding); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB_max_outstanding)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "maxreqs");
    {
	int	RETVAL;
	dXSTARG;
	int	maxreqs = (int)SvIV(ST(0))
;
#line 1478 "BDB.xs"
        RETVAL = max_outstanding;
        max_outstanding = maxreqs;
#line 1452 "BDB.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BDB_dbreq_pri); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB_dbreq_pri)
{
    dVAR; dXSARGS;
    if (items < 0 || items > 1)
       croak_xs_usage(cv,  "pri= 0");
    {
	int	RETVAL;
	dXSTARG;
	int	pri;

	if (items < 1)
	    pri = 0;
	else {
	    pri = (int)SvIV(ST(0))
;
	}
#line 1487 "BDB.xs"
	RETVAL = next_pri - PRI_BIAS;
	if (items > 0)
	  {
	    if (pri < PRI_MIN) pri = PRI_MIN;
	    if (pri > PRI_MAX) pri = PRI_MAX;
	    next_pri = pri + PRI_BIAS;
	  }
#line 1485 "BDB.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BDB_dbreq_nice); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB_dbreq_nice)
{
    dVAR; dXSARGS;
    if (items < 0 || items > 1)
       croak_xs_usage(cv,  "nice= 0");
    {
	int	nice;

	if (items < 1)
	    nice = 0;
	else {
	    nice = (int)SvIV(ST(0))
;
	}
#line 1500 "BDB.xs"
	nice = next_pri - nice;
	if (nice < PRI_MIN) nice = PRI_MIN;
	if (nice > PRI_MAX) nice = PRI_MAX;
	next_pri = nice + PRI_BIAS;
#line 1513 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BDB_flush); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB_flush)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 1509 "BDB.xs"
        while (nreqs)
          {
            poll_wait ();
            poll_cb ();
          }
#line 1532 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BDB_poll); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB_poll)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;
#line 1519 "BDB.xs"
        poll_wait ();
        RETVAL = poll_cb ();
#line 1550 "BDB.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BDB_poll_fileno); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB_poll_fileno)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;
#line 1528 "BDB.xs"
        RETVAL = s_epipe_fd (&respipe);
#line 1569 "BDB.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BDB_poll_cb); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB_poll_cb)
{
    dVAR; dXSARGS;
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    {
	int	RETVAL;
	dXSTARG;
#line 1536 "BDB.xs"
        RETVAL = poll_cb ();
#line 1588 "BDB.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BDB_poll_wait); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB_poll_wait)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 1544 "BDB.xs"
        poll_wait ();
#line 1605 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BDB_nreqs); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB_nreqs)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;
#line 1550 "BDB.xs"
        RETVAL = nreqs;
#line 1622 "BDB.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BDB_nready); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB_nready)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;
#line 1558 "BDB.xs"
        RETVAL = get_nready ();
#line 1641 "BDB.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BDB_npending); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB_npending)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;
#line 1566 "BDB.xs"
        RETVAL = get_npending ();
#line 1660 "BDB.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BDB_nthreads); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB_nthreads)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;
#line 1574 "BDB.xs"
        if (WORDACCESS_UNSAFE) X_LOCK   (wrklock);
        RETVAL = started;
        if (WORDACCESS_UNSAFE) X_UNLOCK (wrklock);
#line 1681 "BDB.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BDB_set_sync_prepare); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB_set_sync_prepare)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "cb");
    {
	SV *	RETVAL;
	SV *	cb = ST(0)
;
#line 1584 "BDB.xs"
        RETVAL = prepare_cb;
        prepare_cb = newSVsv (cb);
#line 1702 "BDB.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BDB_strerror); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB_strerror)
{
    dVAR; dXSARGS;
    if (items < 0 || items > 1)
       croak_xs_usage(cv,  "errorno= errno");
    {
	char *	RETVAL;
	dXSTARG;
	int	errorno;

	if (items < 1)
	    errorno = errno;
	else {
	    errorno = (int)SvIV(ST(0))
;
	}
#line 1593 "BDB.xs"
        RETVAL = db_strerror (errorno);
#line 1729 "BDB.c"
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BDB__on_next_submit); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB__on_next_submit)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "cb");
    {
	SV *	cb = ST(0)
;
#line 1599 "BDB.xs"
        SvREFCNT_dec (on_next_submit);
        on_next_submit = SvOK (cb) ? newSVsv (cb) : 0;
#line 1750 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BDB_db_env_create); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB_db_env_create)
{
    dVAR; dXSARGS;
    if (items < 0 || items > 1)
       croak_xs_usage(cv,  "env_flags= 0");
    {
	DB_ENV *	RETVAL;
	U32	env_flags;

	if (items < 1)
	    env_flags = 0;
	else {
	    env_flags = (unsigned long)SvUV(ST(0))
;
	}
#line 1605 "BDB.xs"
{
        errno = db_env_create (&RETVAL, env_flags);
        if (errno)
          croak ("db_env_create: %s", db_strerror (errno));

        if (0)
          {
            RETVAL->set_errcall (RETVAL, debug_errcall);
            RETVAL->set_msgcall (RETVAL, debug_msgcall);
          }
}
#line 1784 "BDB.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newSVptr (RETVAL, bdb_env_stash);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BDB_db_env_open); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB_db_env_open)
{
    dVAR; dXSARGS;
    if (items < 4 || items > 5)
       croak_xs_usage(cv,  "env, db_home, open_flags, mode, callback= 0");
    {
#line 1622 "BDB.xs"
        CALLBACK
#line 1805 "BDB.c"
	DB_ENV *	env;
	bdb_filename	db_home;
	U32	open_flags = (unsigned long)SvUV(ST(2))
;
	int	mode = (int)SvIV(ST(3))
;
	SV *	callback;

        SvPTR (env, ST(0), DB_ENV *, bdb_env_stash, BDB::Env, 0)
;

        (db_home) = get_bdb_filename (ST(1))
;

	if (items < 5)
	    callback = 0;
	else {
	    callback = ST(4)
;
	}
#line 1624 "BDB.xs"
{
        dREQ (REQ_ENV_OPEN, 1);
        req->env   = env;
        req->uint1 = open_flags | DB_THREAD;
        req->int1  = mode;
        req->buf1  = strdup_ornull (db_home);
        REQ_SEND;
}
#line 1835 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BDB_db_env_close); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB_db_env_close)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "env, flags= 0, callback= 0");
    {
#line 1636 "BDB.xs"
        CALLBACK
#line 1850 "BDB.c"
	DB_ENV *	env;
	U32	flags;
	SV *	callback;

        SvPTR (env, ST(0), DB_ENV *, bdb_env_stash, BDB::Env, 0)
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(1))
;
	}

	if (items < 3)
	    callback = 0;
	else {
	    callback = ST(2)
;
	}
#line 1638 "BDB.xs"
{
	dREQ (REQ_ENV_CLOSE, 0);
        ptr_nuke (ST (0));
        req->env   = env;
        req->uint1 = flags;
        REQ_SEND;
}
#line 1879 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BDB_db_env_txn_checkpoint); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB_db_env_txn_checkpoint)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 5)
       croak_xs_usage(cv,  "env, kbyte= 0, min= 0, flags= 0, callback= 0");
    {
#line 1649 "BDB.xs"
        CALLBACK
#line 1894 "BDB.c"
	DB_ENV *	env;
	U32	kbyte;
	U32	min;
	U32	flags;
	SV *	callback;

        SvPTR (env, ST(0), DB_ENV *, bdb_env_stash, BDB::Env, 0)
;

	if (items < 2)
	    kbyte = 0;
	else {
	    kbyte = (unsigned long)SvUV(ST(1))
;
	}

	if (items < 3)
	    min = 0;
	else {
	    min = (unsigned long)SvUV(ST(2))
;
	}

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(3))
;
	}

	if (items < 5)
	    callback = 0;
	else {
	    callback = ST(4)
;
	}
#line 1651 "BDB.xs"
{
        dREQ (REQ_ENV_TXN_CHECKPOINT, 1);
        req->env   = env;
        req->uint1 = kbyte;
        req->int1  = min;
        req->uint2 = flags;
        REQ_SEND;
}
#line 1940 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BDB_db_env_lock_detect); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB_db_env_lock_detect)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 5)
       croak_xs_usage(cv,  "env, flags= 0, atype= DB_LOCK_DEFAULT, dummy= 0, callback= 0");
    {
#line 1663 "BDB.xs"
        CALLBACK
#line 1955 "BDB.c"
	DB_ENV *	env;
	U32	flags;
	U32	atype;
	SV *	dummy;
	SV *	callback;

        SvPTR (env, ST(0), DB_ENV *, bdb_env_stash, BDB::Env, 0)
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(1))
;
	}

	if (items < 3)
	    atype = DB_LOCK_DEFAULT;
	else {
	    atype = (unsigned long)SvUV(ST(2))
;
	}

	if (items < 4)
	    dummy = 0;
	else {
	    dummy = ST(3)
;
	}

	if (items < 5)
	    callback = 0;
	else {
	    callback = ST(4)
;
	}
#line 1665 "BDB.xs"
{
        dREQ (REQ_ENV_LOCK_DETECT, 1);
        req->env   = env;
        req->uint1 = flags;
        req->uint2 = atype;
        /* req->int2  = 0; dummy */
        REQ_SEND;
}
#line 2001 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BDB_db_env_memp_sync); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB_db_env_memp_sync)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "env, dummy= 0, callback= 0");
    {
#line 1677 "BDB.xs"
        CALLBACK
#line 2016 "BDB.c"
	DB_ENV *	env;
	SV *	dummy;
	SV *	callback;

        SvPTR (env, ST(0), DB_ENV *, bdb_env_stash, BDB::Env, 0)
;

	if (items < 2)
	    dummy = 0;
	else {
	    dummy = ST(1)
;
	}

	if (items < 3)
	    callback = 0;
	else {
	    callback = ST(2)
;
	}
#line 1679 "BDB.xs"
{
        dREQ (REQ_ENV_MEMP_SYNC, 1);
        req->env  = env;
        REQ_SEND;
}
#line 2043 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BDB_db_env_memp_trickle); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB_db_env_memp_trickle)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 4)
       croak_xs_usage(cv,  "env, percent, dummy= 0, callback= 0");
    {
#line 1688 "BDB.xs"
        CALLBACK
#line 2058 "BDB.c"
	DB_ENV *	env;
	int	percent = (int)SvIV(ST(1))
;
	SV *	dummy;
	SV *	callback;

        SvPTR (env, ST(0), DB_ENV *, bdb_env_stash, BDB::Env, 0)
;

	if (items < 3)
	    dummy = 0;
	else {
	    dummy = ST(2)
;
	}

	if (items < 4)
	    callback = 0;
	else {
	    callback = ST(3)
;
	}
#line 1690 "BDB.xs"
{
        dREQ (REQ_ENV_MEMP_TRICKLE, 1);
        req->env  = env;
        req->int1 = percent;
        REQ_SEND;
}
#line 2088 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BDB_db_env_dbremove); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB_db_env_dbremove)
{
    dVAR; dXSARGS;
    if (items < 4 || items > 6)
       croak_xs_usage(cv,  "env, txnid, file, database, flags= 0, callback= 0");
    {
#line 1700 "BDB.xs"
        CALLBACK
#line 2103 "BDB.c"
	DB_ENV *	env;
	DB_TXN_ornull *	txnid;
	bdb_filename	file;
	bdb_filename	database;
	U32	flags;
	SV *	callback;

        SvPTR (env, ST(0), DB_ENV *, bdb_env_stash, BDB::Env, 0)
;

        SvPTR (txnid, ST(1), DB_TXN *, bdb_txn_stash, BDB::Txn, 1)
;

        (file) = get_bdb_filename (ST(2))
;

        (database) = get_bdb_filename (ST(3))
;

	if (items < 5)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(4))
;
	}

	if (items < 6)
	    callback = 0;
	else {
	    callback = ST(5)
;
	}
#line 1702 "BDB.xs"
{
	dREQ (REQ_ENV_DBREMOVE, 2);
        req->env   = env;
        req->buf1  = strdup_ornull (file);
        req->buf2  = strdup_ornull (database);
        req->uint1 = flags;
        REQ_SEND;
}
#line 2145 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BDB_db_env_dbrename); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB_db_env_dbrename)
{
    dVAR; dXSARGS;
    if (items < 5 || items > 7)
       croak_xs_usage(cv,  "env, txnid, file, database, newname, flags= 0, callback= 0");
    {
#line 1714 "BDB.xs"
        CALLBACK
#line 2160 "BDB.c"
	DB_ENV *	env;
	DB_TXN_ornull *	txnid;
	bdb_filename	file;
	bdb_filename	database;
	bdb_filename	newname;
	U32	flags;
	SV *	callback;

        SvPTR (env, ST(0), DB_ENV *, bdb_env_stash, BDB::Env, 0)
;

        SvPTR (txnid, ST(1), DB_TXN *, bdb_txn_stash, BDB::Txn, 1)
;

        (file) = get_bdb_filename (ST(2))
;

        (database) = get_bdb_filename (ST(3))
;

        (newname) = get_bdb_filename (ST(4))
;

	if (items < 6)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(5))
;
	}

	if (items < 7)
	    callback = 0;
	else {
	    callback = ST(6)
;
	}
#line 1716 "BDB.xs"
{
	dREQ (REQ_ENV_DBRENAME, 2);
        req->env   = env;
        req->buf1  = strdup_ornull (file);
        req->buf2  = strdup_ornull (database);
        req->buf3  = strdup_ornull (newname);
        req->uint1 = flags;
        REQ_SEND;
}
#line 2207 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BDB_db_env_lsn_reset); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB_db_env_lsn_reset)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items < 2 || items > 4)
       croak_xs_usage(cv,  "env, db, flags= 0, callback= 0");
    {
#line 1731 "BDB.xs"
        CALLBACK
#line 2223 "BDB.c"
	DB_ENV *	env;
	bdb_filename	db;
	U32	flags;
	SV *	callback;

        SvPTR (env, ST(0), DB_ENV *, bdb_env_stash, BDB::Env, 0)
;

        (db) = get_bdb_filename (ST(1))
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(2))
;
	}

	if (items < 4)
	    callback = 0;
	else {
	    callback = ST(3)
;
	}
#line 1733 "BDB.xs"
{
        dREQ (ix ? REQ_ENV_FILEID_RESET : REQ_ENV_LSN_RESET, 1);
        req->env   = env;
        req->uint1 = flags;
        req->buf1  = strdup_ornull (db);
        REQ_SEND;
}
#line 2256 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BDB_db_env_log_archive); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB_db_env_log_archive)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 4)
       croak_xs_usage(cv,  "env, listp, flags= 0, callback= 0");
    {
#line 1744 "BDB.xs"
        CALLBACK
#line 2271 "BDB.c"
	DB_ENV *	env;
	SV_mutable *	listp;
	U32	flags;
	SV *	callback;

        SvPTR (env, ST(0), DB_ENV *, bdb_env_stash, BDB::Env, 0)
;

	(listp) = ST(1);
        if (SvREADONLY (listp))
          croak ("argument \"%s\" is read-only/constant, but %s needs to write results into it",
                 "listp",
                 "BDB::db_env_log_archive");
        if (SvPOKp (listp) && !sv_utf8_downgrade (listp, 1))
          croak ("argument \"%s\" must be byte/octet-encoded in %s",
                 "listp",
                 "BDB::db_env_log_archive")
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(2))
;
	}

	if (items < 4)
	    callback = 0;
	else {
	    callback = ST(3)
;
	}
#line 1746 "BDB.xs"
{
	dREQ (REQ_ENV_LOG_ARCHIVE, 1);
        req->sv1   = SvREFCNT_inc (listp);
        req->env   = env;
        req->uint1 = flags;
        REQ_SEND;
}
#line 2312 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BDB_db_create); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB_db_create)
{
    dVAR; dXSARGS;
    if (items < 0 || items > 2)
       croak_xs_usage(cv,  "env= 0, flags= 0");
    {
	DB *	RETVAL;
	DB_ENV *	env;
	U32	flags;

	if (items < 1)
	    env = 0;
	else {
	SvPTR (env, ST(0), DB_ENV *, bdb_env_stash, BDB::Env, 0)
;
	}

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(1))
;
	}
#line 1757 "BDB.xs"
{
        errno = db_create (&RETVAL, env, flags);
        if (errno)
          croak ("db_create: %s", db_strerror (errno));

        if (RETVAL)
          RETVAL->app_private = (void *)newSVsv (ST (0));
}
#line 2351 "BDB.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newSVptr (RETVAL, bdb_db_stash);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BDB_db_open); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB_db_open)
{
    dVAR; dXSARGS;
    if (items < 7 || items > 8)
       croak_xs_usage(cv,  "db, txnid, file, database, type, flags, mode, callback= 0");
    {
#line 1771 "BDB.xs"
        CALLBACK
#line 2372 "BDB.c"
	DB *	db;
	DB_TXN_ornull *	txnid;
	bdb_filename	file;
	bdb_filename	database;
	int	type = (int)SvIV(ST(4))
;
	U32	flags = (unsigned long)SvUV(ST(5))
;
	int	mode = (int)SvIV(ST(6))
;
	SV *	callback;

        SvPTR (db, ST(0), DB *, bdb_db_stash, BDB::Db, 0)
;

        SvPTR (txnid, ST(1), DB_TXN *, bdb_txn_stash, BDB::Txn, 1)
;

        (file) = get_bdb_filename (ST(2))
;

        (database) = get_bdb_filename (ST(3))
;

	if (items < 8)
	    callback = 0;
	else {
	    callback = ST(7)
;
	}
#line 1773 "BDB.xs"
{
        dREQ (REQ_DB_OPEN, 2);
        req->db    = db;
        req->txn   = txnid;
        req->buf1  = strdup_ornull (file);
        req->buf2  = strdup_ornull (database);
        req->int1  = type;
        req->uint1 = flags | DB_THREAD;
        req->int2  = mode;
        REQ_SEND;
}
#line 2415 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BDB_db_close); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB_db_close)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "db, flags= 0, callback= 0");
    {
#line 1788 "BDB.xs"
        CALLBACK
#line 2430 "BDB.c"
	DB *	db;
	U32	flags;
	SV *	callback;

        SvPTR (db, ST(0), DB *, bdb_db_stash, BDB::Db, 0)
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(1))
;
	}

	if (items < 3)
	    callback = 0;
	else {
	    callback = ST(2)
;
	}
#line 1790 "BDB.xs"
{
        dREQ (REQ_DB_CLOSE, 0);
        ptr_nuke (ST (0));
        req->db    = db;
        req->uint1 = flags;
        req->sv1   = (SV *)db->app_private;
        REQ_SEND;
}
#line 2460 "BDB.c"
    }
    XSRETURN_EMPTY;
}

#if DBVER >= 404
#define XSubPPtmpAAAA 1


XS_EUPXS(XS_BDB_db_compact); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB_db_compact)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 8)
       croak_xs_usage(cv,  "db, txn= 0, start= 0, stop= 0, unused1= 0, flags= DB_FREE_SPACE, unused2= 0, callback= 0");
    {
#line 1804 "BDB.xs"
        CALLBACK
#line 2478 "BDB.c"
	DB *	db;
	DB_TXN_ornull *	txn;
	SV *	start;
	SV *	stop;
	SV *	unused1;
	U32	flags;
	SV *	unused2;
	SV *	callback;

        SvPTR (db, ST(0), DB *, bdb_db_stash, BDB::Db, 0)
;

	if (items < 2)
	    txn = 0;
	else {
	SvPTR (txn, ST(1), DB_TXN *, bdb_txn_stash, BDB::Txn, 1)
;
	}

	if (items < 3)
	    start = 0;
	else {
	    start = ST(2)
;
	}

	if (items < 4)
	    stop = 0;
	else {
	    stop = ST(3)
;
	}

	if (items < 5)
	    unused1 = 0;
	else {
	    unused1 = ST(4)
;
	}

	if (items < 6)
	    flags = DB_FREE_SPACE;
	else {
	    flags = (unsigned long)SvUV(ST(5))
;
	}

	if (items < 7)
	    unused2 = 0;
	else {
	    unused2 = ST(6)
;
	}

	if (items < 8)
	    callback = 0;
	else {
	    callback = ST(7)
;
	}
#line 1806 "BDB.xs"
{
        dREQ (REQ_DB_COMPACT, 2);
        req->db    = db;
        req->txn   = txn;
        if (start) sv_to_dbt (&req->dbt1, start);
        if (stop ) sv_to_dbt (&req->dbt2, stop );
        req->uint1 = flags;
        REQ_SEND;
}
#line 2549 "BDB.c"
    }
    XSRETURN_EMPTY;
}

#endif

XS_EUPXS(XS_BDB_db_sync); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB_db_sync)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "db, flags= 0, callback= 0");
    {
#line 1821 "BDB.xs"
        CALLBACK
#line 2565 "BDB.c"
	DB *	db;
	U32	flags;
	SV *	callback;

        SvPTR (db, ST(0), DB *, bdb_db_stash, BDB::Db, 0)
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(1))
;
	}

	if (items < 3)
	    callback = 0;
	else {
	    callback = ST(2)
;
	}
#line 1823 "BDB.xs"
{
        dREQ (REQ_DB_SYNC, 1);
        req->db    = db;
        req->uint1 = flags;
        REQ_SEND;
}
#line 2593 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BDB_db_verify); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB_db_verify)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 6)
       croak_xs_usage(cv,  "db, file, database= 0, dummy= 0, flags= 0, callback= 0");
    {
#line 1833 "BDB.xs"
        CALLBACK
#line 2608 "BDB.c"
	DB *	db;
	bdb_filename	file;
	bdb_filename	database;
	SV *	dummy;
	U32	flags;
	SV *	callback;

        SvPTR (db, ST(0), DB *, bdb_db_stash, BDB::Db, 0)
;

        (file) = get_bdb_filename (ST(1))
;

	if (items < 3)
	    database = 0;
	else {
	(database) = get_bdb_filename (ST(2))
;
	}

	if (items < 4)
	    dummy = 0;
	else {
	    dummy = ST(3)
;
	}

	if (items < 5)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(4))
;
	}

	if (items < 6)
	    callback = 0;
	else {
	    callback = ST(5)
;
	}
#line 1835 "BDB.xs"
{
        dREQ (REQ_DB_VERIFY, 1);
        ptr_nuke (ST (0)); /* verify destroys the database handle, hopefully it is freed as well */
        req->db    = db;
        req->buf1  = strdup (file);
        req->buf2  = strdup_ornull (database);
        req->uint1 = flags;
        REQ_SEND;
}
#line 2659 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BDB_db_upgrade); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB_db_upgrade)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 4)
       croak_xs_usage(cv,  "db, file, flags= 0, callback= 0");
    {
#line 1848 "BDB.xs"
        CALLBACK
#line 2674 "BDB.c"
	DB *	db;
	bdb_filename	file;
	U32	flags;
	SV *	callback;

        SvPTR (db, ST(0), DB *, bdb_db_stash, BDB::Db, 0)
;

        (file) = get_bdb_filename (ST(1))
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(2))
;
	}

	if (items < 4)
	    callback = 0;
	else {
	    callback = ST(3)
;
	}
#line 1850 "BDB.xs"
{
        dREQ (REQ_DB_UPGRADE, 1);
        req->db    = db;
        req->buf1  = strdup (file);
        req->uint1 = flags;
        REQ_SEND;
}
#line 2707 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BDB_db_key_range); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB_db_key_range)
{
    dVAR; dXSARGS;
    if (items < 4 || items > 6)
       croak_xs_usage(cv,  "db, txn, key, key_range, flags= 0, callback= 0");
    {
#line 1861 "BDB.xs"
        CALLBACK
#line 2722 "BDB.c"
	DB *	db;
	DB_TXN_ornull *	txn;
	SV *	key = ST(2)
;
	SV_mutable *	key_range;
	U32	flags;
	SV *	callback;

        SvPTR (db, ST(0), DB *, bdb_db_stash, BDB::Db, 0)
;

        SvPTR (txn, ST(1), DB_TXN *, bdb_txn_stash, BDB::Txn, 1)
;

	(key_range) = ST(3);
        if (SvREADONLY (key_range))
          croak ("argument \"%s\" is read-only/constant, but %s needs to write results into it",
                 "key_range",
                 "BDB::db_key_range");
        if (SvPOKp (key_range) && !sv_utf8_downgrade (key_range, 1))
          croak ("argument \"%s\" must be byte/octet-encoded in %s",
                 "key_range",
                 "BDB::db_key_range")
;

	if (items < 5)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(4))
;
	}

	if (items < 6)
	    callback = 0;
	else {
	    callback = ST(5)
;
	}
#line 1863 "BDB.xs"
{
        dREQ (REQ_DB_KEY_RANGE, 2);
        req->db    = db;
        req->txn   = txn;
        sv_to_dbt (&req->dbt1, key);
        req->uint1 = flags;
        req->sv1   = SvREFCNT_inc (key_range); SvREADONLY_on (key_range);
        REQ_SEND;
}
#line 2771 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BDB_db_put); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB_db_put)
{
    dVAR; dXSARGS;
    if (items < 4 || items > 6)
       croak_xs_usage(cv,  "db, txn, key, data, flags= 0, callback= 0");
    {
#line 1876 "BDB.xs"
        CALLBACK
#line 2786 "BDB.c"
	DB *	db;
	DB_TXN_ornull *	txn;
	SV *	key = ST(2)
;
	SV *	data = ST(3)
;
	U32	flags;
	SV *	callback;

        SvPTR (db, ST(0), DB *, bdb_db_stash, BDB::Db, 0)
;

        SvPTR (txn, ST(1), DB_TXN *, bdb_txn_stash, BDB::Txn, 1)
;

	if (items < 5)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(4))
;
	}

	if (items < 6)
	    callback = 0;
	else {
	    callback = ST(5)
;
	}
#line 1878 "BDB.xs"
{
        dREQ (REQ_DB_PUT, 2);
        req->db    = db;
        req->txn   = txn;
        sv_to_dbt (&req->dbt1, key);
        sv_to_dbt (&req->dbt2, data);
        req->uint1 = flags;
        REQ_SEND;
}
#line 2825 "BDB.c"
    }
    XSRETURN_EMPTY;
}

#if DBVER >= 406
#define XSubPPtmpAAAB 1


XS_EUPXS(XS_BDB_db_exists); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB_db_exists)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 5)
       croak_xs_usage(cv,  "db, txn, key, flags= 0, callback= 0");
    {
#line 1893 "BDB.xs"
        CALLBACK
#line 2843 "BDB.c"
	DB *	db;
	DB_TXN_ornull *	txn;
	SV *	key = ST(2)
;
	U32	flags;
	SV *	callback;

        SvPTR (db, ST(0), DB *, bdb_db_stash, BDB::Db, 0)
;

        SvPTR (txn, ST(1), DB_TXN *, bdb_txn_stash, BDB::Txn, 1)
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(3))
;
	}

	if (items < 5)
	    callback = 0;
	else {
	    callback = ST(4)
;
	}
#line 1895 "BDB.xs"
{
        dREQ (REQ_DB_EXISTS, 2);
        req->db    = db;
        req->txn   = txn;
        req->uint1 = flags;
        sv_to_dbt (&req->dbt1, key);
        REQ_SEND;
}
#line 2879 "BDB.c"
    }
    XSRETURN_EMPTY;
}

#endif

XS_EUPXS(XS_BDB_db_get); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB_db_get)
{
    dVAR; dXSARGS;
    if (items < 4 || items > 6)
       croak_xs_usage(cv,  "db, txn, key, data, flags= 0, callback= 0");
    {
#line 1909 "BDB.xs"
        CALLBACK
#line 2895 "BDB.c"
	DB *	db;
	DB_TXN_ornull *	txn;
	SV *	key = ST(2)
;
	SV_mutable *	data;
	U32	flags;
	SV *	callback;

        SvPTR (db, ST(0), DB *, bdb_db_stash, BDB::Db, 0)
;

        SvPTR (txn, ST(1), DB_TXN *, bdb_txn_stash, BDB::Txn, 1)
;

	(data) = ST(3);
        if (SvREADONLY (data))
          croak ("argument \"%s\" is read-only/constant, but %s needs to write results into it",
                 "data",
                 "BDB::db_get");
        if (SvPOKp (data) && !sv_utf8_downgrade (data, 1))
          croak ("argument \"%s\" must be byte/octet-encoded in %s",
                 "data",
                 "BDB::db_get")
;

	if (items < 5)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(4))
;
	}

	if (items < 6)
	    callback = 0;
	else {
	    callback = ST(5)
;
	}
#line 1911 "BDB.xs"
{
	//TODO: key is somtimesmutable
        dREQ (REQ_DB_GET, 2);
        req->db    = db;
        req->txn   = txn;
        req->uint1 = flags;
        sv_to_dbt (&req->dbt1, key);
        req->dbt3.flags = DB_DBT_MALLOC;
        req->sv3 = SvREFCNT_inc (data); SvREADONLY_on (data);
        REQ_SEND;
}
#line 2946 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BDB_db_pget); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB_db_pget)
{
    dVAR; dXSARGS;
    if (items < 5 || items > 7)
       croak_xs_usage(cv,  "db, txn, key, pkey, data, flags= 0, callback= 0");
    {
#line 1926 "BDB.xs"
        CALLBACK
#line 2961 "BDB.c"
	DB *	db;
	DB_TXN_ornull *	txn;
	SV *	key = ST(2)
;
	SV_mutable *	pkey;
	SV_mutable *	data;
	U32	flags;
	SV *	callback;

        SvPTR (db, ST(0), DB *, bdb_db_stash, BDB::Db, 0)
;

        SvPTR (txn, ST(1), DB_TXN *, bdb_txn_stash, BDB::Txn, 1)
;

	(pkey) = ST(3);
        if (SvREADONLY (pkey))
          croak ("argument \"%s\" is read-only/constant, but %s needs to write results into it",
                 "pkey",
                 "BDB::db_pget");
        if (SvPOKp (pkey) && !sv_utf8_downgrade (pkey, 1))
          croak ("argument \"%s\" must be byte/octet-encoded in %s",
                 "pkey",
                 "BDB::db_pget")
;

	(data) = ST(4);
        if (SvREADONLY (data))
          croak ("argument \"%s\" is read-only/constant, but %s needs to write results into it",
                 "data",
                 "BDB::db_pget");
        if (SvPOKp (data) && !sv_utf8_downgrade (data, 1))
          croak ("argument \"%s\" must be byte/octet-encoded in %s",
                 "data",
                 "BDB::db_pget")
;

	if (items < 6)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(5))
;
	}

	if (items < 7)
	    callback = 0;
	else {
	    callback = ST(6)
;
	}
#line 1928 "BDB.xs"
{
	//TODO: key is somtimesmutable
        dREQ (REQ_DB_PGET, 2);
        req->db    = db;
        req->txn   = txn;
        req->uint1 = flags;

        sv_to_dbt (&req->dbt1, key);

        req->dbt2.flags = DB_DBT_MALLOC;
        req->sv2 = SvREFCNT_inc (pkey); SvREADONLY_on (pkey);

        req->dbt3.flags = DB_DBT_MALLOC;
        req->sv3 = SvREFCNT_inc (data); SvREADONLY_on (data);
        REQ_SEND;
}
#line 3029 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BDB_db_del); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB_db_del)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 5)
       croak_xs_usage(cv,  "db, txn, key, flags= 0, callback= 0");
    {
#line 1948 "BDB.xs"
        CALLBACK
#line 3044 "BDB.c"
	DB *	db;
	DB_TXN_ornull *	txn;
	SV *	key = ST(2)
;
	U32	flags;
	SV *	callback;

        SvPTR (db, ST(0), DB *, bdb_db_stash, BDB::Db, 0)
;

        SvPTR (txn, ST(1), DB_TXN *, bdb_txn_stash, BDB::Txn, 1)
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(3))
;
	}

	if (items < 5)
	    callback = 0;
	else {
	    callback = ST(4)
;
	}
#line 1950 "BDB.xs"
{
        dREQ (REQ_DB_DEL, 2);
        req->db    = db;
        req->txn   = txn;
        req->uint1 = flags;
        sv_to_dbt (&req->dbt1, key);
        REQ_SEND;
}
#line 3080 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BDB_db_txn_commit); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB_db_txn_commit)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "txn, flags= 0, callback= 0");
    {
#line 1962 "BDB.xs"
        CALLBACK
#line 3095 "BDB.c"
	DB_TXN *	txn;
	U32	flags;
	SV *	callback;

        SvPTR (txn, ST(0), DB_TXN *, bdb_txn_stash, BDB::Txn, 0)
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(1))
;
	}

	if (items < 3)
	    callback = 0;
	else {
	    callback = ST(2)
;
	}
#line 1964 "BDB.xs"
{
        dREQ (REQ_TXN_COMMIT, 0);
        ptr_nuke (ST (0));
        req->txn   = txn;
        req->uint1 = flags;
        REQ_SEND;
}
#line 3124 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BDB_db_txn_abort); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB_db_txn_abort)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "txn, callback= 0");
    {
#line 1975 "BDB.xs"
        CALLBACK
#line 3139 "BDB.c"
	DB_TXN *	txn;
	SV *	callback;

        SvPTR (txn, ST(0), DB_TXN *, bdb_txn_stash, BDB::Txn, 0)
;

	if (items < 2)
	    callback = 0;
	else {
	    callback = ST(1)
;
	}
#line 1977 "BDB.xs"
{
        dREQ (REQ_TXN_ABORT, 0);
        ptr_nuke (ST (0));
        req->txn   = txn;
        REQ_SEND;
}
#line 3159 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BDB_db_txn_finish); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB_db_txn_finish)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "txn, flags= 0, callback= 0");
    {
#line 1987 "BDB.xs"
        CALLBACK
#line 3174 "BDB.c"
	DB_TXN *	txn;
	U32	flags;
	SV *	callback;

        SvPTR (txn, ST(0), DB_TXN *, bdb_txn_stash, BDB::Txn, 0)
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(1))
;
	}

	if (items < 3)
	    callback = 0;
	else {
	    callback = ST(2)
;
	}
#line 1989 "BDB.xs"
{
        dREQ (REQ_TXN_FINISH, 0);
        ptr_nuke (ST (0));
        req->txn   = txn;
        req->uint1 = flags;
        REQ_SEND;
}
#line 3203 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BDB_db_c_close); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB_db_c_close)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dbc, callback= 0");
    {
#line 2000 "BDB.xs"
        CALLBACK
#line 3218 "BDB.c"
	DBC *	dbc;
	SV *	callback;

        SvPTR (dbc, ST(0), DBC *, bdb_cursor_stash, BDB::Cursor, 0)
;

	if (items < 2)
	    callback = 0;
	else {
	    callback = ST(1)
;
	}
#line 2002 "BDB.xs"
{
        dREQ (REQ_C_CLOSE, 0);
        ptr_nuke (ST (0));
        req->dbc = dbc;
        REQ_SEND;
}
#line 3238 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BDB_db_c_count); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB_db_c_count)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 4)
       croak_xs_usage(cv,  "dbc, count, flags= 0, callback= 0");
    {
#line 2012 "BDB.xs"
        CALLBACK
#line 3253 "BDB.c"
	DBC *	dbc;
	SV *	count = ST(1)
;
	U32	flags;
	SV *	callback;

        SvPTR (dbc, ST(0), DBC *, bdb_cursor_stash, BDB::Cursor, 0)
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(2))
;
	}

	if (items < 4)
	    callback = 0;
	else {
	    callback = ST(3)
;
	}
#line 2014 "BDB.xs"
{
        dREQ (REQ_C_COUNT, 1);
        req->dbc = dbc;
        req->sv1 = SvREFCNT_inc (count);
        REQ_SEND;
}
#line 3283 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BDB_db_c_put); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB_db_c_put)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 5)
       croak_xs_usage(cv,  "dbc, key, data, flags= 0, callback= 0");
    {
#line 2024 "BDB.xs"
        CALLBACK
#line 3298 "BDB.c"
	DBC *	dbc;
	SV *	key = ST(1)
;
	SV *	data = ST(2)
;
	U32	flags;
	SV *	callback;

        SvPTR (dbc, ST(0), DBC *, bdb_cursor_stash, BDB::Cursor, 0)
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(3))
;
	}

	if (items < 5)
	    callback = 0;
	else {
	    callback = ST(4)
;
	}
#line 2026 "BDB.xs"
{
        dREQ (REQ_C_PUT, 1);
        req->dbc   = dbc;
        sv_to_dbt (&req->dbt1, key);
        sv_to_dbt (&req->dbt2, data);
        req->uint1 = flags;
        REQ_SEND;
}
#line 3332 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BDB_db_c_get); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB_db_c_get)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 5)
       croak_xs_usage(cv,  "dbc, key, data, flags= 0, callback= 0");
    {
#line 2038 "BDB.xs"
        CALLBACK
#line 3347 "BDB.c"
	DBC *	dbc;
	SV *	key = ST(1)
;
	SV_mutable *	data;
	U32	flags;
	SV *	callback;

        SvPTR (dbc, ST(0), DBC *, bdb_cursor_stash, BDB::Cursor, 0)
;

	(data) = ST(2);
        if (SvREADONLY (data))
          croak ("argument \"%s\" is read-only/constant, but %s needs to write results into it",
                 "data",
                 "BDB::db_c_get");
        if (SvPOKp (data) && !sv_utf8_downgrade (data, 1))
          croak ("argument \"%s\" must be byte/octet-encoded in %s",
                 "data",
                 "BDB::db_c_get")
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(3))
;
	}

	if (items < 5)
	    callback = 0;
	else {
	    callback = ST(4)
;
	}
#line 2040 "BDB.xs"
{
        if ((flags & DB_OPFLAGS_MASK) != DB_SET && SvREADONLY (key))
          croak ("db_c_get was passed a read-only/constant 'key' argument but operation is not DB_SET");
        if (SvPOKp (key) && !sv_utf8_downgrade (key, 1))
          croak ("argument \"%s\" must be byte/octet-encoded in %s",
                 "key",
                 "BDB::db_c_get");

        {
          dREQ (REQ_C_GET, 1);
          req->dbc   = dbc;
          req->uint1 = flags;
          if ((flags & DB_OPFLAGS_MASK) == DB_SET)
            sv_to_dbt (&req->dbt1, key);
          else
            {
              if ((flags & DB_OPFLAGS_MASK) == DB_SET_RANGE)
                sv_to_dbt (&req->dbt1, key);
              else
                req->dbt1.flags = DB_DBT_MALLOC;

              req->sv1 = SvREFCNT_inc (key); SvREADONLY_on (key);
            }

          if ((flags & DB_OPFLAGS_MASK) == DB_GET_BOTH
              || (flags & DB_OPFLAGS_MASK) == DB_GET_BOTH_RANGE)
            sv_to_dbt (&req->dbt3, data);
          else
            req->dbt3.flags = DB_DBT_MALLOC;

          req->sv3 = SvREFCNT_inc (data); SvREADONLY_on (data);
          REQ_SEND;
        }
}
#line 3417 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BDB_db_c_pget); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB_db_c_pget)
{
    dVAR; dXSARGS;
    if (items < 4 || items > 6)
       croak_xs_usage(cv,  "dbc, key, pkey, data, flags= 0, callback= 0");
    {
#line 2078 "BDB.xs"
        CALLBACK
#line 3432 "BDB.c"
	DBC *	dbc;
	SV *	key = ST(1)
;
	SV_mutable *	pkey;
	SV_mutable *	data;
	U32	flags;
	SV *	callback;

        SvPTR (dbc, ST(0), DBC *, bdb_cursor_stash, BDB::Cursor, 0)
;

	(pkey) = ST(2);
        if (SvREADONLY (pkey))
          croak ("argument \"%s\" is read-only/constant, but %s needs to write results into it",
                 "pkey",
                 "BDB::db_c_pget");
        if (SvPOKp (pkey) && !sv_utf8_downgrade (pkey, 1))
          croak ("argument \"%s\" must be byte/octet-encoded in %s",
                 "pkey",
                 "BDB::db_c_pget")
;

	(data) = ST(3);
        if (SvREADONLY (data))
          croak ("argument \"%s\" is read-only/constant, but %s needs to write results into it",
                 "data",
                 "BDB::db_c_pget");
        if (SvPOKp (data) && !sv_utf8_downgrade (data, 1))
          croak ("argument \"%s\" must be byte/octet-encoded in %s",
                 "data",
                 "BDB::db_c_pget")
;

	if (items < 5)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(4))
;
	}

	if (items < 6)
	    callback = 0;
	else {
	    callback = ST(5)
;
	}
#line 2080 "BDB.xs"
{
        if ((flags & DB_OPFLAGS_MASK) != DB_SET && SvREADONLY (key))
          croak ("db_c_pget was passed a read-only/constant 'key' argument but operation is not DB_SET");
        if (SvPOKp (key) && !sv_utf8_downgrade (key, 1))
          croak ("argument \"%s\" must be byte/octet-encoded in %s",
                 "key",
                 "BDB::db_c_pget");

        {
          dREQ (REQ_C_PGET, 1);
          req->dbc   = dbc;
          req->uint1 = flags;
          if ((flags & DB_OPFLAGS_MASK) == DB_SET)
            sv_to_dbt (&req->dbt1, key);
          else
            {
              if ((flags & DB_OPFLAGS_MASK) == DB_SET_RANGE)
                sv_to_dbt (&req->dbt1, key);
              else
                req->dbt1.flags = DB_DBT_MALLOC;

              req->sv1 = SvREFCNT_inc (key); SvREADONLY_on (key);
            }

          req->dbt2.flags = DB_DBT_MALLOC;
          req->sv2 = SvREFCNT_inc (pkey); SvREADONLY_on (pkey);

          if ((flags & DB_OPFLAGS_MASK) == DB_GET_BOTH
              || (flags & DB_OPFLAGS_MASK) == DB_GET_BOTH_RANGE)
            sv_to_dbt (&req->dbt3, data);
          else
            req->dbt3.flags = DB_DBT_MALLOC;

          req->sv3 = SvREFCNT_inc (data); SvREADONLY_on (data);
          REQ_SEND;
        }
}
#line 3517 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BDB_db_c_del); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB_db_c_del)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "dbc, flags= 0, callback= 0");
    {
#line 2121 "BDB.xs"
        CALLBACK
#line 3532 "BDB.c"
	DBC *	dbc;
	U32	flags;
	SV *	callback;

        SvPTR (dbc, ST(0), DBC *, bdb_cursor_stash, BDB::Cursor, 0)
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(1))
;
	}

	if (items < 3)
	    callback = 0;
	else {
	    callback = ST(2)
;
	}
#line 2123 "BDB.xs"
{
        dREQ (REQ_C_DEL, 1);
        req->dbc   = dbc;
        req->uint1 = flags;
        REQ_SEND;
}
#line 3560 "BDB.c"
    }
    XSRETURN_EMPTY;
}

#if DBVER >= 403
#define XSubPPtmpAAAC 1


XS_EUPXS(XS_BDB_db_sequence_open); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB_db_sequence_open)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 5)
       croak_xs_usage(cv,  "seq, txnid, key, flags= 0, callback= 0");
    {
#line 2136 "BDB.xs"
        CALLBACK
#line 3578 "BDB.c"
	DB_SEQUENCE *	seq;
	DB_TXN_ornull *	txnid;
	SV *	key = ST(2)
;
	U32	flags;
	SV *	callback;

        SvPTR (seq, ST(0), DB_SEQUENCE *, bdb_sequence_stash, BDB::Sequence, 0)
;

        SvPTR (txnid, ST(1), DB_TXN *, bdb_txn_stash, BDB::Txn, 1)
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(3))
;
	}

	if (items < 5)
	    callback = 0;
	else {
	    callback = ST(4)
;
	}
#line 2138 "BDB.xs"
{
        dREQ (REQ_SEQ_OPEN, 2);
        req->seq   = seq;
        req->txn   = txnid;
        req->uint1 = flags | DB_THREAD;
        sv_to_dbt (&req->dbt1, key);
        REQ_SEND;
}
#line 3614 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BDB_db_sequence_close); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB_db_sequence_close)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "seq, flags= 0, callback= 0");
    {
#line 2150 "BDB.xs"
        CALLBACK
#line 3629 "BDB.c"
	DB_SEQUENCE *	seq;
	U32	flags;
	SV *	callback;

        SvPTR (seq, ST(0), DB_SEQUENCE *, bdb_sequence_stash, BDB::Sequence, 0)
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(1))
;
	}

	if (items < 3)
	    callback = 0;
	else {
	    callback = ST(2)
;
	}
#line 2152 "BDB.xs"
{
        dREQ (REQ_SEQ_CLOSE, 0);
        ptr_nuke (ST (0));
        req->seq   = seq;
        req->uint1 = flags;
        REQ_SEND;
}
#line 3658 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BDB_db_sequence_get); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB_db_sequence_get)
{
    dVAR; dXSARGS;
    if (items < 4 || items > 6)
       croak_xs_usage(cv,  "seq, txnid, delta, seq_value, flags= DB_TXN_NOSYNC, callback= 0");
    {
#line 2163 "BDB.xs"
        CALLBACK
#line 3673 "BDB.c"
	DB_SEQUENCE *	seq;
	DB_TXN_ornull *	txnid;
	int	delta = (int)SvIV(ST(2))
;
	SV_mutable *	seq_value;
	U32	flags;
	SV *	callback;

        SvPTR (seq, ST(0), DB_SEQUENCE *, bdb_sequence_stash, BDB::Sequence, 0)
;

        SvPTR (txnid, ST(1), DB_TXN *, bdb_txn_stash, BDB::Txn, 1)
;

	(seq_value) = ST(3);
        if (SvREADONLY (seq_value))
          croak ("argument \"%s\" is read-only/constant, but %s needs to write results into it",
                 "seq_value",
                 "BDB::db_sequence_get");
        if (SvPOKp (seq_value) && !sv_utf8_downgrade (seq_value, 1))
          croak ("argument \"%s\" must be byte/octet-encoded in %s",
                 "seq_value",
                 "BDB::db_sequence_get")
;

	if (items < 5)
	    flags = DB_TXN_NOSYNC;
	else {
	    flags = (unsigned long)SvUV(ST(4))
;
	}

	if (items < 6)
	    callback = 0;
	else {
	    callback = ST(5)
;
	}
#line 2165 "BDB.xs"
{
        dREQ (REQ_SEQ_GET, 2);
        req->seq   = seq;
        req->txn   = txnid;
        req->int1  = delta;
        req->uint1 = flags;
        req->sv1   = SvREFCNT_inc (seq_value); SvREADONLY_on (seq_value);
        REQ_SEND;
}
#line 3722 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BDB_db_sequence_remove); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB_db_sequence_remove)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 4)
       croak_xs_usage(cv,  "seq, txnid= 0, flags= 0, callback= 0");
    {
#line 2178 "BDB.xs"
        CALLBACK
#line 3737 "BDB.c"
	DB_SEQUENCE *	seq;
	DB_TXN_ornull *	txnid;
	U32	flags;
	SV *	callback;

        SvPTR (seq, ST(0), DB_SEQUENCE *, bdb_sequence_stash, BDB::Sequence, 0)
;

	if (items < 2)
	    txnid = 0;
	else {
	SvPTR (txnid, ST(1), DB_TXN *, bdb_txn_stash, BDB::Txn, 1)
;
	}

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(2))
;
	}

	if (items < 4)
	    callback = 0;
	else {
	    callback = ST(3)
;
	}
#line 2180 "BDB.xs"
{
        dREQ (REQ_SEQ_REMOVE, 2);
        req->seq   = seq;
        req->txn   = txnid;
        req->uint1 = flags;
        REQ_SEND;
}
#line 3774 "BDB.c"
    }
    XSRETURN_EMPTY;
}

#endif

XS_EUPXS(XS_BDB__Env_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB__Env_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "env");
    {
	DB_ENV_ornuked *	env;

        SvPTR (env, ST(0), DB_ENV *, bdb_env_stash, BDB::Env, 2)
;
#line 2196 "BDB.xs"
        if (env)
          env->close (env, 0);
#line 3795 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BDB__Env_set_data_dir); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB__Env_set_data_dir)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "env, dir");
    {
	int	RETVAL;
	dXSTARG;
	DB_ENV *	env;
	const char *	dir = (const char *)SvPV_nolen(ST(1))
;

        SvPTR (env, ST(0), DB_ENV *, bdb_env_stash, BDB::Env, 0)
;
#line 2201 "BDB.xs"
        RETVAL = env->set_data_dir (env, dir);
#line 3818 "BDB.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BDB__Env_set_tmp_dir); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB__Env_set_tmp_dir)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "env, dir");
    {
	int	RETVAL;
	dXSTARG;
	DB_ENV *	env;
	const char *	dir = (const char *)SvPV_nolen(ST(1))
;

        SvPTR (env, ST(0), DB_ENV *, bdb_env_stash, BDB::Env, 0)
;
#line 2207 "BDB.xs"
        RETVAL = env->set_tmp_dir (env, dir);
#line 3843 "BDB.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BDB__Env_set_lg_dir); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB__Env_set_lg_dir)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "env, dir");
    {
	int	RETVAL;
	dXSTARG;
	DB_ENV *	env;
	const char *	dir = (const char *)SvPV_nolen(ST(1))
;

        SvPTR (env, ST(0), DB_ENV *, bdb_env_stash, BDB::Env, 0)
;
#line 2213 "BDB.xs"
        RETVAL = env->set_lg_dir (env, dir);
#line 3868 "BDB.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BDB__Env_set_shm_key); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB__Env_set_shm_key)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "env, shm_key");
    {
	int	RETVAL;
	dXSTARG;
	DB_ENV *	env;
	long	shm_key = (long)SvIV(ST(1))
;

        SvPTR (env, ST(0), DB_ENV *, bdb_env_stash, BDB::Env, 0)
;
#line 2219 "BDB.xs"
        RETVAL = env->set_shm_key (env, shm_key);
#line 3893 "BDB.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BDB__Env_set_cachesize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB__Env_set_cachesize)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "env, gbytes, bytes, ncache= 0");
    {
	int	RETVAL;
	dXSTARG;
	DB_ENV *	env;
	U32	gbytes = (unsigned long)SvUV(ST(1))
;
	U32	bytes = (unsigned long)SvUV(ST(2))
;
	int	ncache;

        SvPTR (env, ST(0), DB_ENV *, bdb_env_stash, BDB::Env, 0)
;

	if (items < 4)
	    ncache = 0;
	else {
	    ncache = (int)SvIV(ST(3))
;
	}
#line 2225 "BDB.xs"
        RETVAL = env->set_cachesize (env, gbytes, bytes, ncache);
#line 3928 "BDB.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BDB__Env_set_flags); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB__Env_set_flags)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "env, flags, onoff= 1");
    {
	int	RETVAL;
	dXSTARG;
	DB_ENV *	env;
	U32	flags = (unsigned long)SvUV(ST(1))
;
	int	onoff;

        SvPTR (env, ST(0), DB_ENV *, bdb_env_stash, BDB::Env, 0)
;

	if (items < 3)
	    onoff = 1;
	else {
	    onoff = (int)SvIV(ST(2))
;
	}
#line 2231 "BDB.xs"
        RETVAL = env->set_flags (env, flags, onoff);
#line 3961 "BDB.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#if DBVER >= 407
#define XSubPPtmpAAAD 1


XS_EUPXS(XS_BDB__Env_set_intermediate_dir_mode); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB__Env_set_intermediate_dir_mode)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "env, mode");
    {
	int	RETVAL;
	dXSTARG;
	DB_ENV *	env;
	const char *	mode = (const char *)SvPV_nolen(ST(1))
;

        SvPTR (env, ST(0), DB_ENV *, bdb_env_stash, BDB::Env, 0)
;
#line 2239 "BDB.xs"
        RETVAL = env->set_intermediate_dir_mode (env, mode);
#line 3989 "BDB.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BDB__Env_log_set_config); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB__Env_log_set_config)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "env, flags, onoff= 1");
    {
	int	RETVAL;
	dXSTARG;
	DB_ENV *	env;
	U32	flags = (unsigned long)SvUV(ST(1))
;
	int	onoff;

        SvPTR (env, ST(0), DB_ENV *, bdb_env_stash, BDB::Env, 0)
;

	if (items < 3)
	    onoff = 1;
	else {
	    onoff = (int)SvIV(ST(2))
;
	}
#line 2245 "BDB.xs"
        RETVAL = env->log_set_config (env, flags, onoff);
#line 4022 "BDB.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#endif

XS_EUPXS(XS_BDB__Env_set_errfile); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB__Env_set_errfile)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "env, errfile= 0");
    {
	DB_ENV *	env;
	FILE *	errfile;

        SvPTR (env, ST(0), DB_ENV *, bdb_env_stash, BDB::Env, 0)
;

	if (items < 2)
	    errfile = 0;
	else {
	    errfile = PerlIO_findFILE(IoIFP(sv_2io(ST(1))))
;
	}
#line 2254 "BDB.xs"
        env->set_errfile (env, errfile);
#line 4052 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BDB__Env_set_msgfile); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB__Env_set_msgfile)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "env, msgfile= 0");
    {
	DB_ENV *	env;
	FILE *	msgfile;

        SvPTR (env, ST(0), DB_ENV *, bdb_env_stash, BDB::Env, 0)
;

	if (items < 2)
	    msgfile = 0;
	else {
	    msgfile = PerlIO_findFILE(IoIFP(sv_2io(ST(1))))
;
	}
#line 2258 "BDB.xs"
        env->set_msgfile (env, msgfile);
#line 4079 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BDB__Env_set_verbose); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB__Env_set_verbose)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "env, which= -1, onoff= 1");
    {
	int	RETVAL;
	dXSTARG;
	DB_ENV *	env;
	U32	which;
	int	onoff;

        SvPTR (env, ST(0), DB_ENV *, bdb_env_stash, BDB::Env, 0)
;

	if (items < 2)
	    which = -1;
	else {
	    which = (unsigned long)SvUV(ST(1))
;
	}

	if (items < 3)
	    onoff = 1;
	else {
	    onoff = (int)SvIV(ST(2))
;
	}
#line 2262 "BDB.xs"
        RETVAL = env->set_verbose (env, which, onoff);
#line 4116 "BDB.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BDB__Env_set_encrypt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB__Env_set_encrypt)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "env, password, flags= 0");
    {
	int	RETVAL;
	dXSTARG;
	DB_ENV *	env;
	const char *	password = (const char *)SvPV_nolen(ST(1))
;
	U32	flags;

        SvPTR (env, ST(0), DB_ENV *, bdb_env_stash, BDB::Env, 0)
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(2))
;
	}
#line 2268 "BDB.xs"
        RETVAL = env->set_encrypt (env, password, flags);
#line 4149 "BDB.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BDB__Env_set_timeout); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB__Env_set_timeout)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "env, timeout, flags= DB_SET_TXN_TIMEOUT");
    {
	int	RETVAL;
	dXSTARG;
	DB_ENV *	env;
	NV	timeout = (NV)SvNV(ST(1))
;
	U32	flags;

        SvPTR (env, ST(0), DB_ENV *, bdb_env_stash, BDB::Env, 0)
;

	if (items < 3)
	    flags = DB_SET_TXN_TIMEOUT;
	else {
	    flags = (unsigned long)SvUV(ST(2))
;
	}
#line 2274 "BDB.xs"
        RETVAL = env->set_timeout (env, timeout * 1000000, flags);
#line 4182 "BDB.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BDB__Env_set_mp_max_openfd); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB__Env_set_mp_max_openfd)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "env, maxopenfd");
    {
	int	RETVAL;
	dXSTARG;
	DB_ENV *	env;
	int	maxopenfd = (int)SvIV(ST(1))
;

        SvPTR (env, ST(0), DB_ENV *, bdb_env_stash, BDB::Env, 0)
;
#line 2280 "BDB.xs"
        RETVAL = env->set_mp_max_openfd (env, maxopenfd);
#line 4207 "BDB.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BDB__Env_set_mp_max_write); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB__Env_set_mp_max_write)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "env, maxwrite, maxwrite_sleep");
    {
	int	RETVAL;
	dXSTARG;
	DB_ENV *	env;
	int	maxwrite = (int)SvIV(ST(1))
;
	int	maxwrite_sleep = (int)SvIV(ST(2))
;

        SvPTR (env, ST(0), DB_ENV *, bdb_env_stash, BDB::Env, 0)
;
#line 2286 "BDB.xs"
        RETVAL = env->set_mp_max_write (env, maxwrite, maxwrite_sleep);
#line 4234 "BDB.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BDB__Env_set_mp_mmapsize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB__Env_set_mp_mmapsize)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "env, mmapsize_mb");
    {
	int	RETVAL;
	dXSTARG;
	DB_ENV *	env;
	int	mmapsize_mb = (int)SvIV(ST(1))
;

        SvPTR (env, ST(0), DB_ENV *, bdb_env_stash, BDB::Env, 0)
;
#line 2292 "BDB.xs"
        RETVAL = env->set_mp_mmapsize (env, ((size_t)mmapsize_mb) << 20);
#line 4259 "BDB.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BDB__Env_set_lk_detect); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB__Env_set_lk_detect)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "env, detect= DB_LOCK_DEFAULT");
    {
	int	RETVAL;
	dXSTARG;
	DB_ENV *	env;
	U32	detect;

        SvPTR (env, ST(0), DB_ENV *, bdb_env_stash, BDB::Env, 0)
;

	if (items < 2)
	    detect = DB_LOCK_DEFAULT;
	else {
	    detect = (unsigned long)SvUV(ST(1))
;
	}
#line 2298 "BDB.xs"
        RETVAL = env->set_lk_detect (env, detect);
#line 4290 "BDB.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BDB__Env_set_lk_max_lockers); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB__Env_set_lk_max_lockers)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "env, max");
    {
	int	RETVAL;
	dXSTARG;
	DB_ENV *	env;
	U32	max = (unsigned long)SvUV(ST(1))
;

        SvPTR (env, ST(0), DB_ENV *, bdb_env_stash, BDB::Env, 0)
;
#line 2304 "BDB.xs"
        RETVAL = env->set_lk_max_lockers (env, max);
#line 4315 "BDB.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BDB__Env_set_lk_max_locks); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB__Env_set_lk_max_locks)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "env, max");
    {
	int	RETVAL;
	dXSTARG;
	DB_ENV *	env;
	U32	max = (unsigned long)SvUV(ST(1))
;

        SvPTR (env, ST(0), DB_ENV *, bdb_env_stash, BDB::Env, 0)
;
#line 2310 "BDB.xs"
        RETVAL = env->set_lk_max_locks (env, max);
#line 4340 "BDB.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BDB__Env_set_lk_max_objects); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB__Env_set_lk_max_objects)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "env, max");
    {
	int	RETVAL;
	dXSTARG;
	DB_ENV *	env;
	U32	max = (unsigned long)SvUV(ST(1))
;

        SvPTR (env, ST(0), DB_ENV *, bdb_env_stash, BDB::Env, 0)
;
#line 2316 "BDB.xs"
        RETVAL = env->set_lk_max_objects (env, max);
#line 4365 "BDB.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BDB__Env_set_lg_bsize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB__Env_set_lg_bsize)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "env, max");
    {
	int	RETVAL;
	dXSTARG;
	DB_ENV *	env;
	U32	max = (unsigned long)SvUV(ST(1))
;

        SvPTR (env, ST(0), DB_ENV *, bdb_env_stash, BDB::Env, 0)
;
#line 2322 "BDB.xs"
        RETVAL = env->set_lg_bsize (env, max);
#line 4390 "BDB.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BDB__Env_set_lg_max); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB__Env_set_lg_max)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "env, max");
    {
	int	RETVAL;
	dXSTARG;
	DB_ENV *	env;
	U32	max = (unsigned long)SvUV(ST(1))
;

        SvPTR (env, ST(0), DB_ENV *, bdb_env_stash, BDB::Env, 0)
;
#line 2328 "BDB.xs"
        RETVAL = env->set_lg_max (env, max);
#line 4415 "BDB.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#if DBVER >= 404
#define XSubPPtmpAAAE 1


XS_EUPXS(XS_BDB__Env_mutex_set_max); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB__Env_mutex_set_max)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "env, max");
    {
	int	RETVAL;
	dXSTARG;
	DB_ENV *	env;
	U32	max = (unsigned long)SvUV(ST(1))
;

        SvPTR (env, ST(0), DB_ENV *, bdb_env_stash, BDB::Env, 0)
;
#line 2336 "BDB.xs"
        RETVAL = env->mutex_set_max (env, max);
#line 4443 "BDB.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BDB__Env_mutex_set_increment); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB__Env_mutex_set_increment)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "env, increment");
    {
	int	RETVAL;
	dXSTARG;
	DB_ENV *	env;
	U32	increment = (unsigned long)SvUV(ST(1))
;

        SvPTR (env, ST(0), DB_ENV *, bdb_env_stash, BDB::Env, 0)
;
#line 2342 "BDB.xs"
        RETVAL = env->mutex_set_increment (env, increment);
#line 4468 "BDB.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BDB__Env_mutex_set_tas_spins); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB__Env_mutex_set_tas_spins)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "env, tas_spins");
    {
	int	RETVAL;
	dXSTARG;
	DB_ENV *	env;
	U32	tas_spins = (unsigned long)SvUV(ST(1))
;

        SvPTR (env, ST(0), DB_ENV *, bdb_env_stash, BDB::Env, 0)
;
#line 2348 "BDB.xs"
        RETVAL = env->mutex_set_tas_spins (env, tas_spins);
#line 4493 "BDB.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BDB__Env_mutex_set_align); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB__Env_mutex_set_align)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "env, align");
    {
	int	RETVAL;
	dXSTARG;
	DB_ENV *	env;
	U32	align = (unsigned long)SvUV(ST(1))
;

        SvPTR (env, ST(0), DB_ENV *, bdb_env_stash, BDB::Env, 0)
;
#line 2354 "BDB.xs"
        RETVAL = env->mutex_set_align (env, align);
#line 4518 "BDB.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#endif

XS_EUPXS(XS_BDB__Env_txn_begin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB__Env_txn_begin)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "env, parent= 0, flags= 0");
    {
	DB_TXN *	RETVAL;
	DB_ENV *	env;
	DB_TXN_ornull *	parent;
	U32	flags;

        SvPTR (env, ST(0), DB_ENV *, bdb_env_stash, BDB::Env, 0)
;

	if (items < 2)
	    parent = 0;
	else {
	SvPTR (parent, ST(1), DB_TXN *, bdb_txn_stash, BDB::Txn, 1)
;
	}

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(2))
;
	}
#line 2363 "BDB.xs"
        errno = env->txn_begin (env, parent, &RETVAL, flags);
        if (errno)
          croak ("DB_ENV->txn_begin: %s", db_strerror (errno));
#line 4559 "BDB.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newSVptr (RETVAL, bdb_txn_stash);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#if DBVER >= 405
#define XSubPPtmpAAAF 1


XS_EUPXS(XS_BDB__Env_cdsgroup_begin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB__Env_cdsgroup_begin)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "env");
    {
	DB_TXN *	RETVAL;
	DB_ENV *	env;

        SvPTR (env, ST(0), DB_ENV *, bdb_env_stash, BDB::Env, 0)
;
#line 2374 "BDB.xs"
        errno = env->cdsgroup_begin (env, &RETVAL);
        if (errno)
          croak ("DB_ENV->cdsgroup_begin: %s", db_strerror (errno));
#line 4590 "BDB.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newSVptr (RETVAL, bdb_txn_stash);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#endif

XS_EUPXS(XS_BDB__Db_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB__Db_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "db");
    {
	DB_ornuked *	db;

        SvPTR (db, ST(0), DB *, bdb_db_stash, BDB::Db, 2)
;
#line 2387 "BDB.xs"
        if (db)
          {
            SV *env = (SV *)db->app_private;
            db->close (db, 0);
            SvREFCNT_dec (env);
          }
#line 4621 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BDB__Db_set_cachesize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB__Db_set_cachesize)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "db, gbytes, bytes, ncache= 0");
    {
	int	RETVAL;
	dXSTARG;
	DB *	db;
	U32	gbytes = (unsigned long)SvUV(ST(1))
;
	U32	bytes = (unsigned long)SvUV(ST(2))
;
	int	ncache;

        SvPTR (db, ST(0), DB *, bdb_db_stash, BDB::Db, 0)
;

	if (items < 4)
	    ncache = 0;
	else {
	    ncache = (int)SvIV(ST(3))
;
	}
#line 2396 "BDB.xs"
        RETVAL = db->set_cachesize (db, gbytes, bytes, ncache);
#line 4654 "BDB.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BDB__Db_set_pagesize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB__Db_set_pagesize)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "db, pagesize");
    {
	int	RETVAL;
	dXSTARG;
	DB *	db;
	U32	pagesize = (unsigned long)SvUV(ST(1))
;

        SvPTR (db, ST(0), DB *, bdb_db_stash, BDB::Db, 0)
;
#line 2402 "BDB.xs"
        RETVAL = db->set_pagesize (db, pagesize);
#line 4679 "BDB.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BDB__Db_set_flags); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB__Db_set_flags)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "db, flags");
    {
	int	RETVAL;
	dXSTARG;
	DB *	db;
	U32	flags = (unsigned long)SvUV(ST(1))
;

        SvPTR (db, ST(0), DB *, bdb_db_stash, BDB::Db, 0)
;
#line 2408 "BDB.xs"
        RETVAL = db->set_flags (db, flags);
#line 4704 "BDB.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BDB__Db_set_encrypt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB__Db_set_encrypt)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "db, password, flags");
    {
	int	RETVAL;
	dXSTARG;
	DB *	db;
	const char *	password = (const char *)SvPV_nolen(ST(1))
;
	U32	flags = (unsigned long)SvUV(ST(2))
;

        SvPTR (db, ST(0), DB *, bdb_db_stash, BDB::Db, 0)
;
#line 2414 "BDB.xs"
        RETVAL = db->set_encrypt (db, password, flags);
#line 4731 "BDB.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BDB__Db_set_lorder); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB__Db_set_lorder)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "db, lorder");
    {
	int	RETVAL;
	dXSTARG;
	DB *	db;
	int	lorder = (int)SvIV(ST(1))
;

        SvPTR (db, ST(0), DB *, bdb_db_stash, BDB::Db, 0)
;
#line 2420 "BDB.xs"
        RETVAL = db->set_lorder (db, lorder);
#line 4756 "BDB.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BDB__Db_set_bt_minkey); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB__Db_set_bt_minkey)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "db, minkey");
    {
	int	RETVAL;
	dXSTARG;
	DB *	db;
	U32	minkey = (unsigned long)SvUV(ST(1))
;

        SvPTR (db, ST(0), DB *, bdb_db_stash, BDB::Db, 0)
;
#line 2426 "BDB.xs"
        RETVAL = db->set_bt_minkey (db, minkey);
#line 4781 "BDB.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BDB__Db_set_re_delim); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB__Db_set_re_delim)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "db, delim");
    {
	int	RETVAL;
	dXSTARG;
	DB *	db;
	int	delim = (int)SvIV(ST(1))
;

        SvPTR (db, ST(0), DB *, bdb_db_stash, BDB::Db, 0)
;
#line 2432 "BDB.xs"
        RETVAL = db->set_re_delim (db, delim);
#line 4806 "BDB.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BDB__Db_set_re_pad); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB__Db_set_re_pad)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "db, re_pad");
    {
	int	RETVAL;
	dXSTARG;
	DB *	db;
	int	re_pad = (int)SvIV(ST(1))
;

        SvPTR (db, ST(0), DB *, bdb_db_stash, BDB::Db, 0)
;
#line 2438 "BDB.xs"
        RETVAL = db->set_re_pad (db, re_pad);
#line 4831 "BDB.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BDB__Db_set_re_source); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB__Db_set_re_source)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "db, source");
    {
	int	RETVAL;
	dXSTARG;
	DB *	db;
	char *	source = (char *)SvPV_nolen(ST(1))
;

        SvPTR (db, ST(0), DB *, bdb_db_stash, BDB::Db, 0)
;
#line 2444 "BDB.xs"
        RETVAL = db->set_re_source (db, source);
#line 4856 "BDB.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BDB__Db_set_re_len); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB__Db_set_re_len)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "db, re_len");
    {
	int	RETVAL;
	dXSTARG;
	DB *	db;
	U32	re_len = (unsigned long)SvUV(ST(1))
;

        SvPTR (db, ST(0), DB *, bdb_db_stash, BDB::Db, 0)
;
#line 2450 "BDB.xs"
        RETVAL = db->set_re_len (db, re_len);
#line 4881 "BDB.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BDB__Db_set_h_ffactor); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB__Db_set_h_ffactor)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "db, h_ffactor");
    {
	int	RETVAL;
	dXSTARG;
	DB *	db;
	U32	h_ffactor = (unsigned long)SvUV(ST(1))
;

        SvPTR (db, ST(0), DB *, bdb_db_stash, BDB::Db, 0)
;
#line 2456 "BDB.xs"
        RETVAL = db->set_h_ffactor (db, h_ffactor);
#line 4906 "BDB.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BDB__Db_set_h_nelem); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB__Db_set_h_nelem)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "db, h_nelem");
    {
	int	RETVAL;
	dXSTARG;
	DB *	db;
	U32	h_nelem = (unsigned long)SvUV(ST(1))
;

        SvPTR (db, ST(0), DB *, bdb_db_stash, BDB::Db, 0)
;
#line 2462 "BDB.xs"
        RETVAL = db->set_h_nelem (db, h_nelem);
#line 4931 "BDB.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BDB__Db_set_q_extentsize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB__Db_set_q_extentsize)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "db, extentsize");
    {
	int	RETVAL;
	dXSTARG;
	DB *	db;
	U32	extentsize = (unsigned long)SvUV(ST(1))
;

        SvPTR (db, ST(0), DB *, bdb_db_stash, BDB::Db, 0)
;
#line 2468 "BDB.xs"
        RETVAL = db->set_q_extentsize (db, extentsize);
#line 4956 "BDB.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BDB__Db_cursor); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB__Db_cursor)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "db, txn= 0, flags= 0");
    {
	DBC *	RETVAL;
	DB *	db;
	DB_TXN_ornull *	txn;
	U32	flags;

        SvPTR (db, ST(0), DB *, bdb_db_stash, BDB::Db, 0)
;

	if (items < 2)
	    txn = 0;
	else {
	SvPTR (txn, ST(1), DB_TXN *, bdb_txn_stash, BDB::Txn, 1)
;
	}

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(2))
;
	}
#line 2475 "BDB.xs"
        errno = db->cursor (db, txn, &RETVAL, flags);
        if (errno)
          croak ("DB->cursor: %s", db_strerror (errno));
#line 4996 "BDB.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newSVptr (RETVAL, bdb_cursor_stash);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#if DBVER >= 403
#define XSubPPtmpAAAG 1


XS_EUPXS(XS_BDB__Db_sequence); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB__Db_sequence)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "db, flags= 0");
    {
	DB_SEQUENCE *	RETVAL;
	DB *	db;
	U32	flags;

        SvPTR (db, ST(0), DB *, bdb_db_stash, BDB::Db, 0)
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(1))
;
	}
#line 2486 "BDB.xs"
{
        errno = db_sequence_create (&RETVAL, db, flags);
        if (errno)
          croak ("db_sequence_create: %s", db_strerror (errno));
}
#line 5037 "BDB.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newSVptr (RETVAL, bdb_sequence_stash);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#endif

XS_EUPXS(XS_BDB__Txn_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB__Txn_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "txn");
    {
	DB_TXN_ornuked *	txn;

        SvPTR (txn, ST(0), DB_TXN *, bdb_txn_stash, BDB::Txn, 2)
;
#line 2502 "BDB.xs"
        if (txn)
          txn->abort (txn);
#line 5064 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BDB__Txn_set_timeout); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB__Txn_set_timeout)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "txn, timeout, flags= DB_SET_TXN_TIMEOUT");
    {
	int	RETVAL;
	dXSTARG;
	DB_TXN *	txn;
	NV	timeout = (NV)SvNV(ST(1))
;
	U32	flags;

        SvPTR (txn, ST(0), DB_TXN *, bdb_txn_stash, BDB::Txn, 0)
;

	if (items < 3)
	    flags = DB_SET_TXN_TIMEOUT;
	else {
	    flags = (unsigned long)SvUV(ST(2))
;
	}
#line 2507 "BDB.xs"
        RETVAL = txn->set_timeout (txn, timeout * 1000000, flags);
#line 5095 "BDB.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BDB__Txn_failed); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB__Txn_failed)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "txn");
    {
	int	RETVAL;
	dXSTARG;
	DB_TXN *	txn;

        SvPTR (txn, ST(0), DB_TXN *, bdb_txn_stash, BDB::Txn, 0)
;
#line 2513 "BDB.xs"
        RETVAL = !!(txn->flags & TXN_DEADLOCK);
#line 5118 "BDB.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BDB__Cursor_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB__Cursor_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dbc");
    {
	DBC_ornuked *	dbc;

        SvPTR (dbc, ST(0), DBC *, bdb_cursor_stash, BDB::Cursor, 2)
;
#line 2523 "BDB.xs"
        if (dbc)
          dbc->c_close (dbc);
#line 5140 "BDB.c"
    }
    XSRETURN_EMPTY;
}

#if DBVER >= 406
#define XSubPPtmpAAAH 1


XS_EUPXS(XS_BDB__Cursor_set_priority); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB__Cursor_set_priority)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "dbc, priority");
    {
	int	RETVAL;
	dXSTARG;
	DBC *	dbc;
	int	priority = (int)SvIV(ST(1))
;

        SvPTR (dbc, ST(0), DBC *, bdb_cursor_stash, BDB::Cursor, 0)
;
#line 2530 "BDB.xs"
        dbc->set_priority (dbc, priority);
#line 5166 "BDB.c"
    }
    XSRETURN(1);
}

#endif
#if DBVER >= 403
#define XSubPPtmpAAAI 1


XS_EUPXS(XS_BDB__Sequence_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB__Sequence_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "seq");
    {
	DB_SEQUENCE_ornuked *	seq;

        SvPTR (seq, ST(0), DB_SEQUENCE *, bdb_sequence_stash, BDB::Sequence, 2)
;
#line 2541 "BDB.xs"
        if (seq)
          seq->close (seq, 0);
#line 5190 "BDB.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_BDB__Sequence_initial_value); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB__Sequence_initial_value)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "seq, value");
    {
	int	RETVAL;
	dXSTARG;
	DB_SEQUENCE *	seq;
	db_seq_t	value = sizeof (IV) > 4 ? SvIV (ST(1)) : SvNV (ST(1))
;

        SvPTR (seq, ST(0), DB_SEQUENCE *, bdb_sequence_stash, BDB::Sequence, 0)
;
#line 2546 "BDB.xs"
        RETVAL = seq->initial_value (seq, value);
#line 5213 "BDB.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BDB__Sequence_set_cachesize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB__Sequence_set_cachesize)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "seq, size");
    {
	int	RETVAL;
	dXSTARG;
	DB_SEQUENCE *	seq;
	U32	size = (unsigned long)SvUV(ST(1))
;

        SvPTR (seq, ST(0), DB_SEQUENCE *, bdb_sequence_stash, BDB::Sequence, 0)
;
#line 2552 "BDB.xs"
        RETVAL = seq->set_cachesize (seq, size);
#line 5238 "BDB.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BDB__Sequence_set_flags); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB__Sequence_set_flags)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "seq, flags");
    {
	int	RETVAL;
	dXSTARG;
	DB_SEQUENCE *	seq;
	U32	flags = (unsigned long)SvUV(ST(1))
;

        SvPTR (seq, ST(0), DB_SEQUENCE *, bdb_sequence_stash, BDB::Sequence, 0)
;
#line 2558 "BDB.xs"
        RETVAL = seq->set_flags (seq, flags);
#line 5263 "BDB.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_BDB__Sequence_set_range); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_BDB__Sequence_set_range)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "seq, min, max");
    {
	int	RETVAL;
	dXSTARG;
	DB_SEQUENCE *	seq;
	db_seq_t	min = sizeof (IV) > 4 ? SvIV (ST(1)) : SvNV (ST(1))
;
	db_seq_t	max = sizeof (IV) > 4 ? SvIV (ST(2)) : SvNV (ST(2))
;

        SvPTR (seq, ST(0), DB_SEQUENCE *, bdb_sequence_stash, BDB::Sequence, 0)
;
#line 2564 "BDB.xs"
        RETVAL = seq->set_range (seq, min, max);
#line 5290 "BDB.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#endif
#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_BDB); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_BDB)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        (void)newXSproto_portable("BDB::max_poll_reqs", XS_BDB_max_poll_reqs, file, "$");
        (void)newXSproto_portable("BDB::max_poll_time", XS_BDB_max_poll_time, file, "$");
        (void)newXSproto_portable("BDB::min_parallel", XS_BDB_min_parallel, file, "$");
        (void)newXSproto_portable("BDB::max_parallel", XS_BDB_max_parallel, file, "$");
        (void)newXSproto_portable("BDB::max_idle", XS_BDB_max_idle, file, "$");
        (void)newXSproto_portable("BDB::max_outstanding", XS_BDB_max_outstanding, file, "$");
        (void)newXSproto_portable("BDB::dbreq_pri", XS_BDB_dbreq_pri, file, ";$");
        (void)newXSproto_portable("BDB::dbreq_nice", XS_BDB_dbreq_nice, file, ";$");
        (void)newXSproto_portable("BDB::flush", XS_BDB_flush, file, "");
        (void)newXSproto_portable("BDB::poll", XS_BDB_poll, file, "");
        (void)newXSproto_portable("BDB::poll_fileno", XS_BDB_poll_fileno, file, "");
        (void)newXSproto_portable("BDB::poll_cb", XS_BDB_poll_cb, file, "");
        (void)newXSproto_portable("BDB::poll_wait", XS_BDB_poll_wait, file, "");
        (void)newXSproto_portable("BDB::nreqs", XS_BDB_nreqs, file, "");
        (void)newXSproto_portable("BDB::nready", XS_BDB_nready, file, "");
        (void)newXSproto_portable("BDB::npending", XS_BDB_npending, file, "");
        (void)newXSproto_portable("BDB::nthreads", XS_BDB_nthreads, file, "");
        (void)newXSproto_portable("BDB::set_sync_prepare", XS_BDB_set_sync_prepare, file, "&");
        (void)newXSproto_portable("BDB::strerror", XS_BDB_strerror, file, ";$");
        (void)newXSproto_portable("BDB::_on_next_submit", XS_BDB__on_next_submit, file, "$");
        (void)newXSproto_portable("BDB::db_env_create", XS_BDB_db_env_create, file, ";$");
        (void)newXSproto_portable("BDB::db_env_open", XS_BDB_db_env_open, file, "$$$$;$");
        (void)newXSproto_portable("BDB::db_env_close", XS_BDB_db_env_close, file, "$;$$");
        (void)newXSproto_portable("BDB::db_env_txn_checkpoint", XS_BDB_db_env_txn_checkpoint, file, "$;$$$$");
        (void)newXSproto_portable("BDB::db_env_lock_detect", XS_BDB_db_env_lock_detect, file, "$;$$$$");
        (void)newXSproto_portable("BDB::db_env_memp_sync", XS_BDB_db_env_memp_sync, file, "$;$$");
        (void)newXSproto_portable("BDB::db_env_memp_trickle", XS_BDB_db_env_memp_trickle, file, "$$;$$");
        (void)newXSproto_portable("BDB::db_env_dbremove", XS_BDB_db_env_dbremove, file, "$$$$;$$");
        (void)newXSproto_portable("BDB::db_env_dbrename", XS_BDB_db_env_dbrename, file, "$$$$$;$$");
        cv = newXSproto_portable("BDB::db_env_fileid_reset", XS_BDB_db_env_lsn_reset, file, "$$;$$");
        XSANY.any_i32 = 1;
        cv = newXSproto_portable("BDB::db_env_lsn_reset", XS_BDB_db_env_lsn_reset, file, "$$;$$");
        XSANY.any_i32 = 0;
        (void)newXSproto_portable("BDB::db_env_log_archive", XS_BDB_db_env_log_archive, file, "$$;$$");
        (void)newXSproto_portable("BDB::db_create", XS_BDB_db_create, file, ";$$");
        (void)newXSproto_portable("BDB::db_open", XS_BDB_db_open, file, "$$$$$$$;$");
        (void)newXSproto_portable("BDB::db_close", XS_BDB_db_close, file, "$;$$");
#if XSubPPtmpAAAA
        (void)newXSproto_portable("BDB::db_compact", XS_BDB_db_compact, file, "$;$$$$$$$");
#endif
        (void)newXSproto_portable("BDB::db_sync", XS_BDB_db_sync, file, "$;$$");
        (void)newXSproto_portable("BDB::db_verify", XS_BDB_db_verify, file, "$$;$$$$");
        (void)newXSproto_portable("BDB::db_upgrade", XS_BDB_db_upgrade, file, "$$;$$");
        (void)newXSproto_portable("BDB::db_key_range", XS_BDB_db_key_range, file, "$$$$;$$");
        (void)newXSproto_portable("BDB::db_put", XS_BDB_db_put, file, "$$$$;$$");
#if XSubPPtmpAAAB
        (void)newXSproto_portable("BDB::db_exists", XS_BDB_db_exists, file, "$$$;$$");
#endif
        (void)newXSproto_portable("BDB::db_get", XS_BDB_db_get, file, "$$$$;$$");
        (void)newXSproto_portable("BDB::db_pget", XS_BDB_db_pget, file, "$$$$$;$$");
        (void)newXSproto_portable("BDB::db_del", XS_BDB_db_del, file, "$$$;$$");
        (void)newXSproto_portable("BDB::db_txn_commit", XS_BDB_db_txn_commit, file, "$;$$");
        (void)newXSproto_portable("BDB::db_txn_abort", XS_BDB_db_txn_abort, file, "$;$");
        (void)newXSproto_portable("BDB::db_txn_finish", XS_BDB_db_txn_finish, file, "$;$$");
        (void)newXSproto_portable("BDB::db_c_close", XS_BDB_db_c_close, file, "$;$");
        (void)newXSproto_portable("BDB::db_c_count", XS_BDB_db_c_count, file, "$$;$$");
        (void)newXSproto_portable("BDB::db_c_put", XS_BDB_db_c_put, file, "$$$;$$");
        (void)newXSproto_portable("BDB::db_c_get", XS_BDB_db_c_get, file, "$$$;$$");
        (void)newXSproto_portable("BDB::db_c_pget", XS_BDB_db_c_pget, file, "$$$$;$$");
        (void)newXSproto_portable("BDB::db_c_del", XS_BDB_db_c_del, file, "$;$$");
#if XSubPPtmpAAAC
        (void)newXSproto_portable("BDB::db_sequence_open", XS_BDB_db_sequence_open, file, "$$$;$$");
        (void)newXSproto_portable("BDB::db_sequence_close", XS_BDB_db_sequence_close, file, "$;$$");
        (void)newXSproto_portable("BDB::db_sequence_get", XS_BDB_db_sequence_get, file, "$$$$;$$");
        (void)newXSproto_portable("BDB::db_sequence_remove", XS_BDB_db_sequence_remove, file, "$;$$$");
#endif
        (void)newXSproto_portable("BDB::Env::DESTROY", XS_BDB__Env_DESTROY, file, "$");
        (void)newXSproto_portable("BDB::Env::set_data_dir", XS_BDB__Env_set_data_dir, file, "$$");
        (void)newXSproto_portable("BDB::Env::set_tmp_dir", XS_BDB__Env_set_tmp_dir, file, "$$");
        (void)newXSproto_portable("BDB::Env::set_lg_dir", XS_BDB__Env_set_lg_dir, file, "$$");
        (void)newXSproto_portable("BDB::Env::set_shm_key", XS_BDB__Env_set_shm_key, file, "$$");
        (void)newXSproto_portable("BDB::Env::set_cachesize", XS_BDB__Env_set_cachesize, file, "$$$;$");
        (void)newXSproto_portable("BDB::Env::set_flags", XS_BDB__Env_set_flags, file, "$$;$");
#if XSubPPtmpAAAD
        (void)newXSproto_portable("BDB::Env::set_intermediate_dir_mode", XS_BDB__Env_set_intermediate_dir_mode, file, "$$");
        (void)newXSproto_portable("BDB::Env::log_set_config", XS_BDB__Env_log_set_config, file, "$$;$");
#endif
        (void)newXSproto_portable("BDB::Env::set_errfile", XS_BDB__Env_set_errfile, file, "$;$");
        (void)newXSproto_portable("BDB::Env::set_msgfile", XS_BDB__Env_set_msgfile, file, "$;$");
        (void)newXSproto_portable("BDB::Env::set_verbose", XS_BDB__Env_set_verbose, file, "$;$$");
        (void)newXSproto_portable("BDB::Env::set_encrypt", XS_BDB__Env_set_encrypt, file, "$$;$");
        (void)newXSproto_portable("BDB::Env::set_timeout", XS_BDB__Env_set_timeout, file, "$$;$");
        (void)newXSproto_portable("BDB::Env::set_mp_max_openfd", XS_BDB__Env_set_mp_max_openfd, file, "$$");
        (void)newXSproto_portable("BDB::Env::set_mp_max_write", XS_BDB__Env_set_mp_max_write, file, "$$$");
        (void)newXSproto_portable("BDB::Env::set_mp_mmapsize", XS_BDB__Env_set_mp_mmapsize, file, "$$");
        (void)newXSproto_portable("BDB::Env::set_lk_detect", XS_BDB__Env_set_lk_detect, file, "$;$");
        (void)newXSproto_portable("BDB::Env::set_lk_max_lockers", XS_BDB__Env_set_lk_max_lockers, file, "$$");
        (void)newXSproto_portable("BDB::Env::set_lk_max_locks", XS_BDB__Env_set_lk_max_locks, file, "$$");
        (void)newXSproto_portable("BDB::Env::set_lk_max_objects", XS_BDB__Env_set_lk_max_objects, file, "$$");
        (void)newXSproto_portable("BDB::Env::set_lg_bsize", XS_BDB__Env_set_lg_bsize, file, "$$");
        (void)newXSproto_portable("BDB::Env::set_lg_max", XS_BDB__Env_set_lg_max, file, "$$");
#if XSubPPtmpAAAE
        (void)newXSproto_portable("BDB::Env::mutex_set_max", XS_BDB__Env_mutex_set_max, file, "$$");
        (void)newXSproto_portable("BDB::Env::mutex_set_increment", XS_BDB__Env_mutex_set_increment, file, "$$");
        (void)newXSproto_portable("BDB::Env::mutex_set_tas_spins", XS_BDB__Env_mutex_set_tas_spins, file, "$$");
        (void)newXSproto_portable("BDB::Env::mutex_set_align", XS_BDB__Env_mutex_set_align, file, "$$");
#endif
        (void)newXSproto_portable("BDB::Env::txn_begin", XS_BDB__Env_txn_begin, file, "$;$$");
#if XSubPPtmpAAAF
        (void)newXSproto_portable("BDB::Env::cdsgroup_begin", XS_BDB__Env_cdsgroup_begin, file, "$");
#endif
        (void)newXSproto_portable("BDB::Db::DESTROY", XS_BDB__Db_DESTROY, file, "$");
        (void)newXSproto_portable("BDB::Db::set_cachesize", XS_BDB__Db_set_cachesize, file, "$$$;$");
        (void)newXSproto_portable("BDB::Db::set_pagesize", XS_BDB__Db_set_pagesize, file, "$$");
        (void)newXSproto_portable("BDB::Db::set_flags", XS_BDB__Db_set_flags, file, "$$");
        (void)newXSproto_portable("BDB::Db::set_encrypt", XS_BDB__Db_set_encrypt, file, "$$$");
        (void)newXSproto_portable("BDB::Db::set_lorder", XS_BDB__Db_set_lorder, file, "$$");
        (void)newXSproto_portable("BDB::Db::set_bt_minkey", XS_BDB__Db_set_bt_minkey, file, "$$");
        (void)newXSproto_portable("BDB::Db::set_re_delim", XS_BDB__Db_set_re_delim, file, "$$");
        (void)newXSproto_portable("BDB::Db::set_re_pad", XS_BDB__Db_set_re_pad, file, "$$");
        (void)newXSproto_portable("BDB::Db::set_re_source", XS_BDB__Db_set_re_source, file, "$$");
        (void)newXSproto_portable("BDB::Db::set_re_len", XS_BDB__Db_set_re_len, file, "$$");
        (void)newXSproto_portable("BDB::Db::set_h_ffactor", XS_BDB__Db_set_h_ffactor, file, "$$");
        (void)newXSproto_portable("BDB::Db::set_h_nelem", XS_BDB__Db_set_h_nelem, file, "$$");
        (void)newXSproto_portable("BDB::Db::set_q_extentsize", XS_BDB__Db_set_q_extentsize, file, "$$");
        (void)newXSproto_portable("BDB::Db::cursor", XS_BDB__Db_cursor, file, "$;$$");
#if XSubPPtmpAAAG
        (void)newXSproto_portable("BDB::Db::sequence", XS_BDB__Db_sequence, file, "$;$");
#endif
        (void)newXSproto_portable("BDB::Txn::DESTROY", XS_BDB__Txn_DESTROY, file, "$");
        (void)newXSproto_portable("BDB::Txn::set_timeout", XS_BDB__Txn_set_timeout, file, "$$;$");
        (void)newXSproto_portable("BDB::Txn::failed", XS_BDB__Txn_failed, file, "$");
        (void)newXSproto_portable("BDB::Cursor::DESTROY", XS_BDB__Cursor_DESTROY, file, "$");
#if XSubPPtmpAAAH
        (void)newXSproto_portable("BDB::Cursor::set_priority", XS_BDB__Cursor_set_priority, file, "$$");
#endif
#if XSubPPtmpAAAI
        (void)newXSproto_portable("BDB::Sequence::DESTROY", XS_BDB__Sequence_DESTROY, file, "$");
        (void)newXSproto_portable("BDB::Sequence::initial_value", XS_BDB__Sequence_initial_value, file, "$$");
        (void)newXSproto_portable("BDB::Sequence::set_cachesize", XS_BDB__Sequence_set_cachesize, file, "$$");
        (void)newXSproto_portable("BDB::Sequence::set_flags", XS_BDB__Sequence_set_flags, file, "$$");
        (void)newXSproto_portable("BDB::Sequence::set_range", XS_BDB__Sequence_set_range, file, "$$$");
#endif

    /* Initialisation Section */

#line 1204 "BDB.xs"
{
        static const struct {
          const char *name;
          IV iv;
        } *civ, const_iv[] = {
#define const_iv(name) { # name, (IV)DB_ ## name },
#if DBVER <= 408
          const_iv (RPCCLIENT)
#endif
          const_iv (INIT_CDB)
          const_iv (INIT_LOCK)
          const_iv (INIT_LOG)
          const_iv (INIT_MPOOL)
          const_iv (INIT_REP)
          const_iv (INIT_TXN)
          const_iv (RECOVER)
          const_iv (INIT_TXN)
          const_iv (RECOVER_FATAL)
          const_iv (CREATE)
          const_iv (RDONLY)
          const_iv (USE_ENVIRON)
          const_iv (USE_ENVIRON_ROOT)
          const_iv (LOCKDOWN)
          const_iv (PRIVATE)
          const_iv (SYSTEM_MEM)
          const_iv (AUTO_COMMIT)
          const_iv (CDB_ALLDB)
          const_iv (DIRECT_DB)
          const_iv (NOLOCKING)
          const_iv (NOMMAP)
          const_iv (NOPANIC)
          const_iv (OVERWRITE)
          const_iv (PANIC_ENVIRONMENT)
          const_iv (REGION_INIT)
          const_iv (TIME_NOTGRANTED)
          const_iv (TXN_NOSYNC)
          const_iv (TXN_NOT_DURABLE)
          const_iv (TXN_WRITE_NOSYNC)
          const_iv (WRITECURSOR)
          const_iv (YIELDCPU)
          const_iv (ENCRYPT_AES)
#if DBVER < 408
          const_iv (XA_CREATE)
#endif
          const_iv (BTREE)
          const_iv (HASH)
          const_iv (QUEUE)
          const_iv (RECNO)
          const_iv (UNKNOWN)
          const_iv (EXCL)
          const_iv (TRUNCATE)
          const_iv (NOSYNC)
          const_iv (CHKSUM)
          const_iv (ENCRYPT)
          const_iv (DUP)
          const_iv (DUPSORT)
          //const_iv (RECNUM)
          const_iv (RENUMBER)
          const_iv (REVSPLITOFF)
          const_iv (CONSUME)
          const_iv (CONSUME_WAIT)
          const_iv (GET_BOTH)
          const_iv (GET_BOTH_RANGE)
          //const_iv (SET_RECNO)
          //const_iv (MULTIPLE)
          const_iv (SNAPSHOT)
          const_iv (JOIN_ITEM)
          const_iv (JOIN_NOSORT)
          const_iv (RMW)

          const_iv (NOTFOUND)
          const_iv (KEYEMPTY)
          const_iv (LOCK_DEADLOCK)
          const_iv (LOCK_NOTGRANTED)
          const_iv (RUNRECOVERY)
          const_iv (OLD_VERSION)
          const_iv (REP_HANDLE_DEAD)
          const_iv (SECONDARY_BAD)

          const_iv (APPEND)
          const_iv (NODUPDATA)
          const_iv (NOOVERWRITE)

          const_iv (TXN_NOWAIT)
          const_iv (TXN_SYNC)

          const_iv (SET_LOCK_TIMEOUT)
          const_iv (SET_TXN_TIMEOUT)

          const_iv (FIRST)
          const_iv (NEXT)
          const_iv (NEXT_DUP)
          const_iv (NEXT_NODUP)
          const_iv (PREV)
          const_iv (PREV_NODUP)
          const_iv (SET)
          const_iv (SET_RANGE)
          const_iv (LAST)
          const_iv (BEFORE)
          const_iv (AFTER)
          const_iv (CURRENT)
          const_iv (KEYFIRST)
          const_iv (KEYLAST)
          const_iv (NODUPDATA)

          const_iv (FORCE)

          const_iv (LOCK_DEFAULT)
          const_iv (LOCK_EXPIRE)
          const_iv (LOCK_MAXLOCKS)
          const_iv (LOCK_MINLOCKS)
          const_iv (LOCK_MINWRITE)
          const_iv (LOCK_OLDEST)
          const_iv (LOCK_RANDOM)
          const_iv (LOCK_YOUNGEST)

          const_iv (DONOTINDEX)
          const_iv (KEYEMPTY)
          const_iv (KEYEXIST)
          const_iv (LOCK_DEADLOCK)
          const_iv (LOCK_NOTGRANTED)
          const_iv (NOSERVER)
#if DBVER < 502
          const_iv (NOSERVER_HOME)
          const_iv (NOSERVER_ID)
#endif
          const_iv (NOTFOUND)
          const_iv (PAGE_NOTFOUND)
          const_iv (REP_DUPMASTER)
          const_iv (REP_HANDLE_DEAD)
          const_iv (REP_HOLDELECTION)
          const_iv (REP_ISPERM)
          const_iv (REP_NEWMASTER)
          const_iv (REP_NEWSITE)
          const_iv (REP_NOTPERM)
          const_iv (REP_UNAVAIL)
          const_iv (RUNRECOVERY)
          const_iv (SECONDARY_BAD)
          const_iv (VERIFY_BAD)

          const_iv (SALVAGE)
          const_iv (AGGRESSIVE)
          const_iv (PRINTABLE)
          const_iv (NOORDERCHK)
          const_iv (ORDERCHKONLY)

          const_iv (ARCH_ABS)
          const_iv (ARCH_DATA)
          const_iv (ARCH_LOG)
          const_iv (ARCH_REMOVE)

          const_iv (VERB_DEADLOCK)
          const_iv (VERB_RECOVERY)
          const_iv (VERB_REPLICATION)
          const_iv (VERB_WAITSFOR)

          const_iv (VERSION_MAJOR)
          const_iv (VERSION_MINOR)
          const_iv (VERSION_PATCH)
          const_iv (LOGVERSION)
          const_iv (LOGOLDVER)
#if DBVER >= 403
          const_iv (INORDER)
          const_iv (LOCK_MAXWRITE)
          const_iv (SEQ_DEC)
          const_iv (SEQ_INC)
          const_iv (SEQ_WRAP)
          const_iv (BUFFER_SMALL)
          const_iv (LOG_BUFFER_FULL)
          const_iv (VERSION_MISMATCH)
#endif
#if DBVER >= 404
          const_iv (REGISTER)
          const_iv (DSYNC_DB)
          const_iv (READ_COMMITTED)
          const_iv (READ_UNCOMMITTED)
          const_iv (REP_IGNORE)
          const_iv (REP_LOCKOUT)
          const_iv (REP_JOIN_FAILURE)
          const_iv (FREE_SPACE)
          const_iv (FREELIST_ONLY)
          const_iv (VERB_REGISTER)
#endif
#if DBVER >= 405
          const_iv (MULTIVERSION)
          const_iv (TXN_SNAPSHOT)
#endif
#if DBVER >= 406
          const_iv (PREV_DUP)
          const_iv (PRIORITY_UNCHANGED)
          const_iv (PRIORITY_VERY_LOW)
          const_iv (PRIORITY_LOW)
          const_iv (PRIORITY_DEFAULT)
          const_iv (PRIORITY_HIGH)
          const_iv (PRIORITY_VERY_HIGH)
          const_iv (IGNORE_LEASE)
#endif
#if DBVER >= 407
          //const_iv (MULTIPLE_KEY)
          const_iv (LOG_DIRECT)
          const_iv (LOG_DSYNC)
          const_iv (LOG_AUTO_REMOVE)
          const_iv (LOG_IN_MEMORY)
          const_iv (LOG_ZERO)
#else
          const_iv (DIRECT_LOG)
          const_iv (LOG_AUTOREMOVE)
# if DBVER >= 403
          const_iv (DSYNC_LOG)
          const_iv (LOG_INMEMORY)
# endif
#if DBVER >= 408
          const_iv (LOGVERSION_LATCHING)
#endif
#endif
        };

	bdb_stash          = gv_stashpv ("BDB"          , 1);
        bdb_env_stash      = gv_stashpv ("BDB::Env"     , 1);
        bdb_txn_stash      = gv_stashpv ("BDB::Txn"     , 1);
        bdb_cursor_stash   = gv_stashpv ("BDB::Cursor"  , 1);
        bdb_db_stash       = gv_stashpv ("BDB::Db"      , 1);
        bdb_sequence_stash = gv_stashpv ("BDB::Sequence", 1);

        for (civ = const_iv + sizeof (const_iv) / sizeof (const_iv [0]); civ > const_iv; civ--)
          newCONSTSUB (bdb_stash, (char *)civ[-1].name, newSViv (civ[-1].iv));

        prepare_cb = &PL_sv_undef;

        {
          /* we currently only allow version, minor-version and patchlevel to go up to 255 */
          char vstring[3] = { DB_VERSION_MAJOR, DB_VERSION_MINOR, DB_VERSION_PATCH };

          newCONSTSUB (bdb_stash, "VERSION_v", newSVpvn (vstring, 3));
        }

        newCONSTSUB (bdb_stash, "VERSION_STRING", newSVpv (DB_VERSION_STRING, 0));

        create_respipe ();

        X_THREAD_ATFORK (atfork_prepare, atfork_parent, atfork_child);
        patch_errno ();
}

#if XSubPPtmpAAAA
#endif
#if XSubPPtmpAAAB
#endif
#if XSubPPtmpAAAC
#endif
#if XSubPPtmpAAAD
#endif
#if XSubPPtmpAAAE
#endif
#if XSubPPtmpAAAF
#endif
#if XSubPPtmpAAAG
#endif
#if XSubPPtmpAAAH
#endif
#if XSubPPtmpAAAI
#endif
#line 5725 "BDB.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
